using Math;
public double ComputeAngle(double x_o,    double y_o,
                    double x_from, double y_from,
                    double x_to,   double y_to)
{
    double size_from = 0.0;
    double size_to   = 0.0;
    double x_from_on_radius = 0.0; 
    double y_from_on_radius = 0.0;
    double x_to_on_radius = 0.0;
    double y_to_on_radius = 0.0;
    double angle_from = 0.0;
    double angle_to   = 0.0;

    x_from -= x_o;
    x_to   -= x_o;
    y_from -= y_o;
    y_to   -= y_o;

    /* First, let's move x_from to a radius of 1: */
    size_from = sqrt(pow(x_from, 2) + pow(y_from, 2));
    x_from_on_radius = x_from/size_from;
    y_from_on_radius = y_from/size_from;

    size_to = sqrt(pow(x_to, 2) + pow(y_to, 2));
    x_to_on_radius = x_to/size_to;
    y_to_on_radius = y_to/size_to;

    angle_from = asin(y_from_on_radius);
    angle_to = asin(y_to_on_radius);

    if(x_to < 0)
    {
        angle_to = PI - angle_to;
    }
    if(x_from < 0)
    {
        angle_from = PI - angle_from;
    }

    return angle_to - angle_from;
    
}
