/* Copyright (C) 2011 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#include "ella-color.h"

gchar* ella_color_to_string(EllaColor* color)
{
    gchar* color_temp = "";
    gint color_value;
    /* FIXME: there are memory leaks here */
    color_value = (int)(color->red*0xFF);
    if(color_value <= 0xF)
    {
        color_temp = g_strdup_printf("#0%x", color_value);
    }
    else
    {
        color_temp = g_strdup_printf("#%x", color_value);
    }
    color_value = (int)(color->green*0xFF);
    if(color_value <= 0xF)
    {
        color_temp = g_strdup_printf("%s0%x", color_temp, color_value);
    }
    else
    {
        color_temp = g_strdup_printf("%s%x", color_temp, color_value);
    }

    color_value = (int)(color->blue*0xFF);
    if(color_value <= 0xF)
    {
        color_temp = g_strdup_printf("%s0%x", color_temp, color_value);
    }
    else
    {
        color_temp = g_strdup_printf("%s%x", color_temp, color_value);
    }
    return color_temp;
}
