/* Copyright (C) 2010 Lucas Baudin
*
* This file is part of Ella Project.
*
* Ella Project is free software : you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Ella Project is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
*/

#include "ella-dirs.h"

static const gchar* config_dir;
static const gchar* data_dir;

const gchar* ella_dirs_get_user_config_dir(void)
{
    return config_dir;
}

gint ella_dirs_check_create_user_config_dir(void)
{
    /* TODO : we should check if the directory is already here, and if we manage
     * to create it. So, we must handle errors.
     * */
    g_mkdir(g_get_user_config_dir(), 0777);
    config_dir = g_build_filename(g_get_user_config_dir(), "ella", NULL);
    /* TODO : we should check if we managed to create this directory. */
    g_mkdir(config_dir, 0777);
    ella_debug("Config dir: %s\n", config_dir);
    return 0;
}

const gchar* ella_get_data_dir(void)
{
    return data_dir;
}

gint ella_check_data_dir(void)
{
    if(g_file_test("../data/ella_data_flag", G_FILE_TEST_EXISTS) == TRUE)
    {
        data_dir = "../data";
    }
    else if(g_file_test(ELLA_DATADIR, G_FILE_TEST_EXISTS) == TRUE)
    {
        data_dir = ELLA_DATADIR;
    }
    else if(g_file_test("/usr/share/ella", G_FILE_TEST_EXISTS) == TRUE)
    {
        data_dir = "/usr/share/ella";
    }
    else
    {
        g_error("ERROR : no data dir.\n");
    }
    if(!g_path_is_absolute(data_dir))
    {
        data_dir = g_build_filename(g_get_current_dir(), data_dir, NULL);
    }
    ella_debug("We are going to use %s as data dir.\n", data_dir);
    return 0;
}
