namespace Ella
{
    namespace Files
    {
        public bool parse_transform_for_item(Ella.Item item, string css)
        {
            var rules = parse_transform(css);
            for(int i = 0; i < rules.length; i++)
            {
                var rule = rules[i].split("(");
                if(rule.length == 2)
                {
                    switch(rule[0])
                    {
                    case "rotate":
                        item.rotation = rule[1].to_double() * Math.PI / 180;
                        break;
                    case "scale":
                        item.width = rule[1].split(",")[0].to_double();
                        item.height = rule[1].split(",")[1].to_double();
                        break;
                    case "translate":
                        item.x = rule[1].split(",")[0].to_double();
                        item.y = rule[1].split(",")[1].to_double();
                        break;
                    default:
                        print(rule[0] + "\n");
                        break;
                    }
                }
            }
            return true;
        }
        
        public bool parse_path_for_item(Ella.Item item, string css)
        {
            var rule = css.split(" ");
            for(int i = 0; i < rule.length; i++)
            {
                switch(rule[i])
                {
                case "M":
                    break;
                case "L":
                    break;
                default:
                    var points = rule[i].split(",");
                    if(points.length != 2)
                    {
                        print("Bad point: " + rule[i] + "\n");
                        break;
                    }
                    int x = points[0].to_int();
                    int y = points[1].to_int();
                    ((Ella.Path)item).add_point(x, y);
                    break;
                }
            }
            return true;
        }
        
        public bool parse_scale_for_item(Ella.Item item, string css)
        {
            var rule = css.split(",");
            item.width = rule[0].to_double();
            item.height = rule[1].to_double();
            return true;
        }
        
        public bool parse_tr_for_item(Ella.Item item, string css)
        {
            var rule = css.split(",");
            item.x = rule[0].to_double();
            item.y = rule[1].to_double();
            return true;
        }

        public bool parse_css_for_item(Ella.Item item, string css)
        {
            var rules = parse_css(css);
            for(int i = 0; i < rules.length; i++)
            {
                var rule = rules[i].split(":");
                if(rule.length == 2)
                {
                    switch(rule[0].replace(" ", ""))
                    {
                    case "fill":
                        item.parse_color(rule[1]);
                        break;
                    case "stroke":
                        item.parse_color_stroke(rule[1]);
                        break;
                    case "stroke-width":
                        item.line_width = rule[1].to_double();
                        break;
                    case "fill-opacity":
                        item.alpha = rule[1].to_double();
                        break;
                    case "stroke-opacity":
                        item.alpha_stroke = rule[1].to_double();
                        break;
                    case "font-size":
                        item.font_size = rule[1].to_double();
                        break;
                    default:
                        print(rule[0] + "\n");
                        break;
                    }
                }
            }
            return true;
        }
        public bool parse_css_for_layer(Ella.Layer item, string css)
        {
            var rules = parse_css(css);
            for(int i = 0; i < rules.length; i++)
            {
                var rule = rules[i].split(":");
                if(rule.length == 2)
                {
                    switch(rule[0])
                    {
                    case "display":
                        if(rule[1] == "none")
                        {
                            item.visible = false;
                        }
                        break;
                    default:
                        print(rule[0] + "\n");
                        break;
                    }
                }
            }
            return true;
        }
        private string[] parse_css(string css)
        {
            css.replace("\n", "");
            css.replace(" ", "");
            return css.split(";");
        }
        private string[] parse_transform(string css)
        {
            css.replace("\n", "");
            css.replace(" ", "");
            return css.split(")");
        }
    }
}
