/* Copyright (C) 2010 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#include "ella-math-tests.h"

void ella_maths_tests_compute_angle(void)
{
    /* If the first point == the origin */
    g_assert_cmpint(editor_compute_angle(10, 20, 10, 20, 0, 0), ==, -1);
    /* If the second point == the origin */
    g_assert_cmpint(editor_compute_angle(10, 20, 20, 20, 10, 20), ==, -1);

    g_assert_cmpfloat(editor_compute_angle(0, 0, 100, 0, 0, 100), ==, M_PI/2);
    g_assert_cmpfloat(editor_compute_angle(0, 0, 100, 0, -100, 0), ==, M_PI);
    g_assert_cmpfloat(editor_compute_angle(0, 0, 100, 0, 0, -100), ==,-M_PI/2);

    /* With non-horizontal/vertical vector  */
    g_assert_cmpfloat(editor_compute_angle(0, 0, 0, 100, 0, -100), ==,-M_PI);
}
