/* Copyright (C) 2010 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#ifndef H_ELLA_COLOR_SELECTION_27122010
#define H_ELLA_COLOR_SELECTION_27122010

#include <gtk/gtk.h>
#include "ella-color_selection_channel.h"

#include <locale.h>
#include <libintl.h>
#define _(x) gettext(x)

G_BEGIN_DECLS

#define ELLA_COLOR_SELECTION_TYPE            (ella_color_selection_get_type ())
#define ELLA_COLOR_SELECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), ELLA_COLOR_SELECTION_TYPE, EllaColorSelection))
#define ELLA_COLOR_SELECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), ELLA_COLOR_SELECTION_TYPE, EllaColorSelectionClass))
#define ELLA_IS_COLOR_SELECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ELLA_COLOR_SELECTION_TYPE))
#define IS_ELLA_COLOR_SELECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ELLA_COLOR_SELECTION_TYPE))



typedef struct _EllaColorSelection       EllaColorSelection;
typedef struct _EllaColorSelectionClass  EllaColorSelectionClass;

struct _EllaColorSelection
{
  GtkHBox hbox;
  
  EllaColorSelectionChannel* red;
  EllaColorSelectionChannel* green;
  EllaColorSelectionChannel* blue;
  GtkSpinButton* spin_red;
  GtkSpinButton* spin_green;
  GtkSpinButton* spin_blue;
  GtkAdjustment* alpha_adjustment;
  GdkColor* color_value;
};

struct _EllaColorSelectionClass
{
    GtkHBoxClass parent_class;
    void  (* value_changed)  (EllaColorSelection* widget, void* user_data);

};

GType          ella_color_selection_get_type        (void);
GtkWidget*     ella_color_selection_new             (void);
void           ella_color_selection_clear           (EllaColorSelection *ecs);
GdkColor*      ella_color_selection_get_value       (EllaColorSelection *ecs);
gdouble ella_color_selection_get_value_alpha(EllaColorSelection* ecs);
void ella_color_selection_set_value_rgb(EllaColorSelection* ecs, gdouble red, gdouble green, gdouble blue);
void ella_color_selection_set_value_rgba(EllaColorSelection* ecs, gdouble red, gdouble green, gdouble blue, gdouble alpha);

G_END_DECLS
#endif
