/* Copyright (C) 2010 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#ifndef H_ELLA_COLOR_SELECTION_CHANNEL_27122010
#define H_ELLA_COLOR_SELECTION_CHANNEL_27122010

#include <gtk/gtk.h>
#include <math.h>
#include "ella-user_config.h"

G_BEGIN_DECLS


#define ELLA_TYPE_COLOR_SELECTION_CHANNEL             (ella_color_selection_channel_get_type ())
#define ELLA_COLOR_SELECTION_CHANNEL(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), ELLA_TYPE_COLOR_SELECTION_CHANNEL, EllaColorSelectionChannel))
#define ELLA_COLOR_SELECTION_CHANNEL_CLASS(obj)       (G_TYPE_CHECK_CLASS_CAST ((obj), ELLA_COLOR_SELECTION_CHANNEL,  EllaColorSelectionChannelClass))
#define ELLA_IS_COLOR_SELECTION_CHANNEL(obj)          G_TYPE_CHECK_INSTANCE_TYPE(obj, ella_color_selection_channel_get_type())
#define ELLA_IS_COLOR_SELECTION_CHANNEL_CLASS(obj)    (G_TYPE_CHECK_CLASS_TYPE ((obj), ELLA_COLOR_SELECTION_CHANNEL))
#define ELLA_COLOR_SELECTION_CHANNEL_GET_CLASS        (G_TYPE_INSTANCE_GET_CLASS ((obj), ELLA_COLOR_SELECTION_CHANNEL, EllaColorSelectionChannelClass))

/**
 **/
typedef enum
{
    ELLA_COLOR_CHANNEL_RED, /**< For a red channel. */
    ELLA_COLOR_CHANNEL_GREEN, /**< For a green channel. */
    ELLA_COLOR_CHANNEL_BLUE /**< For a blue channel. */
} EllaColorChannelType;

typedef struct _EllaColorSelectionChannel            EllaColorSelectionChannel;
typedef struct _EllaColorSelectionChannelClass       EllaColorSelectionChannelClass;

struct _EllaColorSelectionChannel
{
    GtkDrawingArea parent;
    EllaColorChannelType channel;
    gdouble red, green, blue;
    EllaColorSelectionChannel* color_red;
    EllaColorSelectionChannel* color_blue;
    EllaColorSelectionChannel* color_green;
    gboolean is_pressed;
    /* private */
};
struct _EllaColorSelectionChannelClass
{
    GtkDrawingAreaClass parent_class;
    
    void(*value_changed)(EllaColorSelectionChannel* clock, void* user_data);

};

GtkWidget* ella_color_selection_channel_new(void);
void ella_color_selection_channel_set_channel(EllaColorSelectionChannel* color, EllaColorChannelType type);

GType ella_color_selection_channel_get_type(void);

void ella_color_selection_channel_set_value_r(EllaColorSelectionChannel* color, gdouble value);
void ella_color_selection_channel_set_value_g(EllaColorSelectionChannel* color, gdouble value);
void ella_color_selection_channel_set_value_b(EllaColorSelectionChannel* color, gdouble value);
gdouble ella_color_selection_channel_get_value_r(EllaColorSelectionChannel* color);
gdouble ella_color_selection_channel_get_value_g(EllaColorSelectionChannel* color);
gdouble ella_color_selection_channel_get_value_b(EllaColorSelectionChannel* color);
void ella_color_selection_channel_connect(EllaColorSelectionChannel* color,
                                          gchar* color_name,
                                          EllaColorSelectionChannel* to_connect);

gdouble ella_color_selection_channel_get_value(EllaColorSelectionChannel* color);

G_END_DECLS

#endif
