#ifndef H_BIBLIO_20101130
#define H_BIBLIO_20101130

/* translations */
#include <locale.h>
#include <libintl.h>

/********************************
 * module consacré à la gestion
 * de la bibliothèque d'objets
 *******************************/
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <assert.h>

#include <gtk/gtk.h>

#include <zip.h>

#include "editor/editor.h" /* Pour g_substr */
#include "ellasyms.h" /* Pour LONG_STRING */

enum
{
    BIBLIO_TYPE_COLUMN,
    BIBLIO_NAME_COLUMN,
    BIBLIO_PATH_NAME_COLUMN,
    BIBLIO_VISIBLE_COLUMN,
    BIBLIO_MEMO_COLUMN,  
    BIBLIO_VISIBLE_TEXT,
    BIBLIO_ATOM,
	BIBLIO_SHORT_NAME,
    BIBLIO_N_COLUMN
};

enum
{
    BIBLIO_ATOM_BITMAP,
    BIBLIO_ATOM_SVG,
    BIBLIO_ATOM_WAV,
    BIBLIO_ATOM_SYMBOL,
	BIBLIO_ATOM_CLIP,
	BIBLIO_ATOM_BUTTON
};

enum
{
	BIBLIO_BUTTON_NONE,
	BIBLIO_BUTTON_BITMAP,
	BIBLIO_BUTTON_BOX,
	BIBLIO_BUTTON_ELLIPSE,
	BIBLIO_BUTTON_POLYPATH,
	BIBLIO_BUTTON_OUTLINE,
	BIBLIO_BUTTON_TEXT
};
	
/* variables globales */
GtkListStore *pBiblio; /* pointeur sur le store de la biblio */
GtkWidget *pListViewBiblio;/* permet d'afficher les objets */
//GtkWidget *buttonBiblioRemove;/* obligatoirement externe ! et déclaré dans le .h*/
/* fonctions */
GtkListStore *biblio_init(GtkWidget *win,GtkWidget *butRemove,GtkWidget *buttonBiblioArchive,
                           GtkWidget *buttonBiblioOpenArchive);
GtkTreeView* biblio_get_treview(void);						   
gint biblio_open_archive( gchar* path_to_file, GtkTreeView     *treeview);
void add_tree_list_biblio(GtkListStore *pListStore,gint categorie,gchar *nom,gchar *path,gboolean actif);
void on_buttonBiblioArchive_clicked         (GtkButton       *button,
                                        GtkTreeView     *treeview);
void on_buttonBiblioOpenArchive_clicked     (GtkButton       *button,
                                        GtkTreeView     *treeview);
void biblio_save_biblio(gchar *path_to_file,GtkTreeView     *treeview);
gchar *biblio_parse_svg_file(gchar *nom_fich);
void biblio_clear_items(GtkTreeView* pListView);
gint biblio_init_button (gchar* name, gchar* original_title,
                         gdouble x, gdouble y, gdouble rx, gdouble ry, 
                         gdouble width, gdouble height,
                         gdouble l_w, guint32 f_color, guint32 s_color, gdouble alpha,
						 gchar* path_poly,
                         gchar* path_to_bitmap );

#endif 
