/*
 * Copyright (C) 2010 Lucas Baudin
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */
 
#ifndef H_CALLBACKS_20101130
#define H_CALLBACKS_20101130

/* translations */
#include <locale.h>
#include <libintl.h>

#include <glib/glist.h>
#include <glib/gslist.h>
#include <gtk/gtk.h>

#include "config.h"
#include "filesfuncs.h"
#include "timeline.h"
#include "dialogs/dlgdivers.h"
#include "biblio.h"
#include "clipboard.h"
#include "cursor.h"
#include "dialogs/about.h"
#include "dialogs/page_size.h"
#include "dialogs/misc.h"
#include "ella-dirs.h"
#include "config.h"
#include "ella-files.h"
#include "ella-print.h"

void on_nouveau1_activate         (GtkMenuItem* menuitem, GtkWidget* window1);
void on_ouvrir1_activate          (GtkWidget  *window1, GtkWidget* menu_item);
void on_enregistrer1_activate     (GtkMenuItem* menuitem, GtkWidget* window1);
void on_enregistrer_sous1_activate(GtkMenuItem* menuitem, GtkWidget* window1);

void on_une_image_bitmap1_activate     (GtkMenuItem* menuitem, gpointer user_data);
void on_une_image_vectorielle1_activate(GtkMenuItem* menuitem, gpointer user_data);
void on_importer_son_activate          (GtkMenuItem* menuitem, gpointer user_data);
void on_import_symbol_activate         (GtkMenuItem* menuitem, gpointer user_data);
void on_import_clip_activate         (GtkMenuItem* menuitem, gpointer user_data);

void on_animation_flash1_activate           (GtkWidget* win,
                                        GtkWidget* win2);
void on_animation_svg1_activate             (GtkWidget* win,
                                        GtkWidget* win2);
void on_comme_animation_javascript1_activate(GtkMenuItem* menuitem, GtkWidget* win);

void on_edition_activate (GtkMenuItem* menuitem, gpointer* user_data);
void on_quitter1_activate(GtkMenuItem* menuitem, gpointer* user_data);

void on_options1_activate                        (GtkMenuItem* menuitem, gpointer user_data);
void on_copier1_activate                         (GtkMenuItem* menuitem, gpointer user_data);
void on_coller1_activate                         (GtkMenuItem* menuitem, gpointer user_data);
void on_couper1_activate                         (GtkMenuItem* menuitem, gpointer user_data);

void on_nouveau_calque1_activate                 (GtkMenuItem* menuitem, gpointer user_data);
void on_nouveau_calque_sonore1_activate          (GtkMenuItem* menuitem, gpointer user_data);
void on_new_guide_layer1_activate                (GtkMenuItem* menuitem, gpointer user_data);
void on_dupliquer_calque1_activate               (GtkMenuItem* menuitem, gpointer user_data);
void on_renommer_calque1_activate                (GtkMenuItem* menuitem, gpointer user_data);
void on_remonter_le_calque_sur_la_pile1_activate (GtkMenuItem* menuitem, gpointer user_data);
void on_descendre_le_calque_sur_la_pile1_activate(GtkMenuItem* menuitem, gpointer user_data);
void on_supprimer_calque1_activate               (GtkMenuItem* menuitem, gpointer user_data);
void on_dupliquer1_activate                      (GtkMenuItem* menuitem, gpointer user_data);
void on_deplacer_activate                        (GtkMenuItem* menuitem, gpointer user_data);
void on_monter_activate                          (GtkMenuItem* menuitem, gpointer user_data);
void on_descendre_activate                       (GtkMenuItem* menuitem, gpointer user_data);

void on_modify_object_activate                  (GtkMenuItem* menuitem, gpointer *user_data);
void on_convert_as_button_activate              (GtkMenuItem* menuitem, gpointer *user_data);
void on_edit_as_button_activate                 (GtkMenuItem* menuitem, gpointer *user_data);
void on_add_script_to_button_activate           (GtkMenuItem* menuitem, gpointer *user_data);

void on_rotation1_activate                       (GtkMenuItem* menuitem, gpointer user_data);
void on_90sens_horaire1_activate                 (GtkMenuItem* menuitem, gpointer user_data);
void on_90_anti_horaire1_activate                (GtkMenuItem* menuitem, gpointer user_data);
void on_180_sens_horaire1_activate               (GtkMenuItem* menuitem, gpointer user_data);
void on_270_sens_horaire1_activate               (GtkMenuItem* menuitem, gpointer user_data);										
void on_tout_selectionner1_activate              (GtkMenuItem* menuitem, gpointer user_data);
void on_deselectionner_tout1_activate            (GtkMenuItem* menuitem, gpointer user_data);
void on_supprimer1_activate                      (GtkMenuItem* menuitem, gpointer user_data);

void on_trames1_activate(GtkMenuItem* menuitem, gpointer* user_data);

void on_inserer_trames_activate                       (GtkMenuItem* menuitem, gpointer user_data);
void on_ajouter_apres_la_position_courante1_activate  (GtkMenuItem* menuitem, gpointer user_data);
void on_supprimer2_activate                           (GtkMenuItem* menuitem, gpointer user_data);
void on_supprimer_apres_la_position_courante1_activate(GtkMenuItem* menuitem, gpointer user_data);
void on_supprimer_les_trames_selectionnees1_activate  (GtkMenuItem* menuitem, gpointer user_data);
void on_poser_une_image_cle1_activate                 (GtkMenuItem* menuitem, gpointer user_data);
void on_retirer_une_image_cle1_activate               (GtkMenuItem* menuitem, gpointer user_data);
void on_taille1_activate                              (GtkMenuItem* menuitem, gpointer user_data);
void on_couleur_de_la_page1_activate                  (GtkMenuItem* menuitem, gpointer user_data);
void on_format_animation1_activate                    (GtkMenuItem* menuitem, gpointer user_data);
void on_visualisation_activate                        (GtkMenuItem* menuitem, gpointer user_data);

void on_jouer_animation1_activate                     (GtkMenuItem* menuitem, gpointer* user_data);

void on_editeur_zoom_avant_activate  (GtkMenuItem* menuitem, GtkWidget* combo); 
void on_editeur_zoom_arriere_activate(GtkMenuItem* menuitem, GtkWidget* combo);

void on_a_propos1_activate                (GtkMenuItem* menuitem, gpointer user_data);
void on_help_activate                     (GtkMenuItem* menuitem, gpointer user_data);
void on_utilisation_de_la_souris1_activate(GtkMenuItem* menuitem, gpointer user_data);

gboolean on_window_ella_delete_event(GtkWidget* widget, GdkEvent* event, gpointer* user_data);

void on_poser_une_image_cle_vide1_activate            (GtkMenuItem* menuitem, gpointer user_data);
void on_creer_une_interpolation_de_mouvement1_activate(GtkMenuItem* menuitem, gpointer user_data);
void on_mettre_a_blanc_image_cle1_activate            (GtkMenuItem* menuitem, gpointer user_data);
void on_mettre_a_blanc_image_cle1_activate            (GtkMenuItem* menuitem, gpointer user_data);
void on_remove_interpola_activate                     (GtkMenuItem* menuitem, gpointer user_data); 

void on_buttonNew_clicked (GtkButton* button, GtkWidget* window1);
void on_buttonSave_clicked(GtkButton* button, GtkWidget* window1);

void on_buttonCopy_clicked (GtkButton* button, gpointer user_data);
void on_buttonPaste_clicked(GtkButton* button, gpointer user_data);
void on_buttonCut_clicked  (GtkButton* button, gpointer user_data);
void on_buttonUndo_clicked (GtkButton* button, gpointer user_data);

void on_buttonPlayerPlay_clicked (GtkButton* button, gpointer* user_data);
void on_buttonPlayerPause_clicked(GtkButton* button, gpointer* user_data);
void on_buttonPlayerStop_clicked (GtkButton* button, gpointer* user_data); 

/* callbacks de l'onglet 'transitions' */
void on_checkbuttonInterpola_toggled(GtkToggleButton* togglebutton, gpointer user_data);
void on_checkbuttonRotation_toggled (GtkToggleButton* togglebutton, gpointer user_data);
void on_checkbuttonZoom_toggled     (GtkToggleButton* togglebutton, gpointer user_data);
void on_checkbuttonFading_toggled   (GtkToggleButton* togglebutton, gpointer user_data);
void on_checkbuttonAlpha_toggled    (GtkToggleButton* togglebutton, gpointer user_data);
void on_checkbuttonMorphing_toggled (GtkToggleButton* togglebutton, gpointer user_data);

void on_spinbuttonRotation_changed(GtkWidget* spf, gpointer user_data);
void on_spinbuttonFading_changed  (GtkWidget* spf, gpointer user_data);
void on_spinbuttonAlpha_changed   (GtkWidget* spf, gpointer user_data);
void on_spinbuttonZoom_changed    (GtkWidget* spf, gpointer user_data);

void on_comboTimelineZoom_changed(GtkComboBox* combobox, gpointer user_data);

gboolean get_autoarchive_biblio(void);
void set_autoarchive_biblio(gboolean etat);

void on_recent1_activate(GtkMenuItem* menuitem, GtkWidget* window1);
void on_recent2_activate(GtkMenuItem* menuitem, GtkWidget* window1);
void on_recent3_activate(GtkMenuItem* menuitem, GtkWidget* window1);
void on_recent4_activate(GtkMenuItem* menuitem, GtkWidget* window1);
void on_recent5_activate(GtkMenuItem* menuitem, GtkWidget* window1);
void on_recent6_activate(GtkMenuItem* menuitem, GtkWidget* window1);

void on_align_items1_activate(GtkMenuItem* menuitem, gpointer user_data);
void on_notebook_page_switched(GtkNotebook *notebook, GtkNotebook *notebook_page, int page,   gpointer   *user_data);

void
view_onDragDataReceived(GtkWidget *wgt, GdkDragContext *context, gint x, gint y,
                        GtkSelectionData *seldata, guint info, guint time,
                        gpointer userdata);
void
view_onDragDataReceivedTimeline(GtkWidget *wgt, GdkDragContext *context, gint x, gint y,
                        GtkSelectionData *seldata, guint info, guint time,
                        gpointer userdata);

void ella_get_curent_files_data(EllaFilesData* data);
gint open_file(GtkWidget *window1, gchar *chemin);
#endif 
