/*
copyright 2010 Lucas Baudin <xapantu@gmail.com>
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "callbacks/editor.h"

void on_combobox_zoom_changed(GtkHScale *combo, gpointer user_data)
{
    ella_canvas_set_scale(canvas, gtk_range_get_value(GTK_RANGE(combo))/100.0);
}

void zoom_in(GtkHScale* hscale, GtkWidget* widget)
{
    gtk_range_set_value(GTK_RANGE(hscale), gtk_range_get_value(GTK_RANGE(hscale)) + 10.0);
}

void zoom_out(GtkHScale* hscale, GtkWidget* widget)
{
    gtk_range_set_value(GTK_RANGE(hscale), gtk_range_get_value(GTK_RANGE(hscale)) - 10.0);
}

void on_play_canvas_pressed(GtkWidget* button, gpointer widget)
{
    if(ella_canvas_get_is_playing(canvas))
    {
        gtk_image_set_from_stock(gtk_button_get_image(button), "gtk-media-play", GTK_ICON_SIZE_BUTTON);
        ella_canvas_pause(canvas);
    }
    else
    {
        gtk_image_set_from_stock(gtk_button_get_image(button), "gtk-media-pause", GTK_ICON_SIZE_BUTTON);
        ella_canvas_play(canvas, -1, 1000/timeline_get_movie_freq());
    }
}

void on_canvas_stop(GtkWidget* canvas, GtkWidget* widget)
{
    gtk_image_set_from_stock(gtk_button_get_image(widget), "gtk-media-play", GTK_ICON_SIZE_BUTTON);
}

void on_stop_canvas_pressed(GtkWidget* button, gpointer widget)
{
    ella_canvas_stop(canvas);
}

void on_view_100_pressed(GtkWidget* button, gpointer widget)
{
    ella_canvas_set_scale(canvas, 1);
    gtk_range_set_value(GTK_RANGE(widget), 100);
}

void on_remove_activate(GtkWidget* button, gpointer widget)
{
    ella_canvas_remove_selected_item(canvas);
}

void on_select_all_activate(GtkWidget* button, gpointer widget)
{
    ella_canvas_select_all_items(canvas);
}

void on_unselect_all_activate(GtkWidget* button, gpointer widget)
{
    ella_canvas_unselect_all_items(canvas);
}

gboolean on_center_activate(GtkScrolledWindow* widget, GtkWidget* button)
{
    GtkWidget* adj = gtk_scrolled_window_get_hadjustment(widget);
    gtk_adjustment_set_value(adj, gtk_adjustment_get_upper(adj)/2  - gtk_adjustment_get_page_size(adj)/2);
    adj = gtk_scrolled_window_get_vadjustment(widget);
    gtk_adjustment_set_value(adj, gtk_adjustment_get_upper(adj)/2  - gtk_adjustment_get_page_size(adj)/2);
    return FALSE;
}

void editor_on_frame_changed(GtkWidget* canvas, gint frame)
{
    ella_timeline_set_position(timeline, frame);
}
