#include "cursor.h"

/* some icons are from mtpaint ! thanks */
static GdkCursor *CursorNew;

/*************************************/
/* busy cursor           */
/***********************************/
void cursor_busy(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_WATCH);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* hand cursor           */
/***********************************/
void cursor_hand(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_FLEUR);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* resize cursor           */
/***********************************/
void cursor_resize(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_SIZING);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* rotate cursor           */
/***********************************/
void cursor_rotate(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_EXCHANGE);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* line cursor           */
/***********************************/
void cursor_line(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_PENCIL);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* box cursor           */
/***********************************/
void cursor_box(GtkWidget *w)
{
	#if 0
#define xbm_square_width 20
#define xbm_square_height 20
static unsigned char xbm_square_bits[] = {
   0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x06, 0x00, 0x00, 0x0e, 0x00, 0x00,
   0x1e, 0x00, 0x00, 0x3e, 0x00, 0x00, 0x7e, 0x00, 0x00, 0xfe, 0xf8, 0x07,
   0xfe, 0x09, 0x04, 0x3e, 0x08, 0x04, 0x36, 0x08, 0x04, 0x62, 0x08, 0x04,
   0x60, 0x08, 0x04, 0xc0, 0x08, 0x04, 0xc0, 0xf8, 0x07, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
#define xbm_square_mask_width 20
#define xbm_square_mask_height 20
static unsigned char xbm_square_mask_bits[] = {
 0x02, 0x00, 0x00, 0x07, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x1F, 0x00, 0x00,
 0x3F, 0x00, 0x00, 0x7F, 0x00, 0x00, 0xFF, 0xFC, 0x0F, 0xFF, 0xFD, 0x0F,
 0xFF, 0xFF, 0x0F, 0xFF, 0x1F, 0x0E, 0x7F, 0x1C, 0x0E, 0xF7, 0x1C, 0x0E,
 0xF3, 0x1C, 0x0E, 0xE0, 0xFD, 0x0F, 0xE0, 0xFD, 0x0F, 0xC0, 0xFD, 0x0F,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
 };   GdkPixmap *source, *mask;
 GdkColor fg = { 0, 65535, 65535, 65535 }; /* white */
 GdkColor bg = { 0, 0, 0, 0 }; /* black. */

 source = gdk_bitmap_create_from_data (NULL, (const gchar *)xbm_square_bits,
                                       xbm_square_width, xbm_square_height);
 mask = gdk_bitmap_create_from_data (NULL, (const gchar *)xbm_square_mask_bits,
                                     xbm_square_mask_width, xbm_square_mask_height);

 CursorNew = gdk_cursor_new_from_pixmap (source, mask, &fg, &bg, 0, 0);
 g_object_unref (source);
 g_object_unref (mask);
 
 //gdk_window_set_cursor (w->window, CursorNew);
 gdk_flush();	
#endif
}
/*************************************/
/* circle cursor           */
/***********************************/
void cursor_circle(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_CIRCLE);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* text cursor           */
/***********************************/
void cursor_text(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_XTERM);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/* image cursor           */
/***********************************/
void cursor_image(GtkWidget *w)
{
	CursorNew = gdk_cursor_new(GDK_PLUS);
	//gdk_window_set_cursor(w->window, CursorNew );
	gdk_flush();
}
/*************************************/
/*  normal cursor         */
/***********************************/
void cursor_normal(GtkWidget *w)
{
	//gdk_window_set_cursor(w->window,  NULL);
	if (CursorNew!=NULL)
	  gdk_cursor_unref( CursorNew );
	gdk_flush();
}
/*************************************/
/*  path cursor         */
/***********************************/
void cursor_path(GtkWidget *w)
{
	#if 0
#define xbm_line_width 20
#define xbm_line_height 20
static unsigned char xbm_line_bits[] = {
 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x06, 0xF0, 0x03, 0x0E, 0xF0, 0x03,
 0x1E, 0x80, 0x03, 0x3E, 0xF0, 0x03, 0x7E, 0xF0, 0x03, 0xFE, 0xC0, 0x03,
 0xFE, 0xF1, 0x03, 0x3E, 0xF0, 0x03, 0x36, 0x80, 0x03, 0x62, 0xF0, 0x03,
 0x60, 0xF0, 0x03, 0xC0, 0xC0, 0x03, 0xC0, 0xF0, 0x03, 0x00, 0xF0, 0x03,
 0x00, 0x80, 0x03, 0x00, 0xF0, 0x03, 0x00, 0xF0, 0x03, 0x00, 0x00, 0x00
 };
#define xbm_line_mask_width 20
#define xbm_line_mask_height 20
static unsigned char xbm_line_mask_bits[] = {
 0x02, 0x00, 0x00, 0x07, 0xF8, 0x07, 0x0F, 0xF8, 0x07, 0x1F, 0xF8, 0x07,
 0x3F, 0xF8, 0x07, 0x7F, 0xF8, 0x07, 0xFF, 0xF8, 0x07, 0xFF, 0xF9, 0x07,
 0xFF, 0xFB, 0x07, 0xFF, 0xFB, 0x07, 0x7F, 0xF8, 0x07, 0xF7, 0xF8, 0x07,
 0xF3, 0xF8, 0x07, 0xE0, 0xF9, 0x07, 0xE0, 0xF9, 0x07, 0xC0, 0xF8, 0x07,
 0x00, 0xF8, 0x07, 0x00, 0xF8, 0x07, 0x00, 0xF8, 0x07, 0x00, 0xF8, 0x07
 };
 GdkPixmap *source, *mask;
 GdkColor fg = { 0, 65535, 65535, 65535 }; /* white */
 GdkColor bg = { 0, 0, 0, 0 }; /* black. */

 source = gdk_bitmap_create_from_data (NULL, (const gchar *)xbm_line_bits,
                                       xbm_line_width, xbm_line_height);
 mask = gdk_bitmap_create_from_data (NULL, (const gchar *)xbm_line_mask_bits,
                                     xbm_line_mask_width, xbm_line_mask_height);
									 
 CursorNew = gdk_cursor_new_from_pixmap (source, mask, &fg, &bg, 0, 0);
 g_object_unref (source);
 g_object_unref (mask);
 
 //gdk_window_set_cursor (w->window, CursorNew);
 gdk_flush();
 #endif
}
