#ifndef H_DLGEDITEUR_20101130
#define H_DLGEDITEUR_20101130

/* translations */
#include <locale.h>
#include <libintl.h>

/****************************
 * dialogues pour l' éditeur
 ***************************/
#include <gtk/gtk.h>
#include "ella-files.h"
#include "ella-dirs.h"
#include "filesfuncs.h"

/* Messages. */
#define DLGEDITEUR_COLORFILL_TITLE "Choix de la couleur de remplissage"
#define DLGEDITEUR_COLORPAGE_TITLE "Choix de la couleur de fond de la scene"
#define DLGEDITEUR_COLORSTROKE_TITLE "Choix de la couleur de contour"

gchar* dlg_couleur(const gchar* message);
PangoFontDescription* dlg_fontes(gchar* message, gchar* current_font);
gchar *dlg_saisie_text(gchar *message, const gchar *txt_actuel);
GtkWidget* create_dialogColorsAlpha(GdkColor scolor, GdkColor fcolor,
                                    GdkColor pcolor, gint alpha, gint page);

/* Fonctions permettant de lire depuis un autre module les valeurs choisies. */
gint dlg_editeur_get_alpha(void);
GdkColor dlg_editeur_get_scolor(void);
GdkColor dlg_editeur_get_fcolor(void);

GtkWidget* create_DialogImportImageFile(gchar* titre,
                                        const gchar* filtre1,
                                        const gchar* filtre2,
                                        const gchar* filtre3);

/* Imports images. */
GdkPixbuf* dlg_import_image(gint e_w, gint e_h);

#endif 
