/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "dialogs/dlgdivers.h"

/**********************
 * icones
 *********************/
#include "./icones_rcs/high_align.xpm"
#include "./icones_rcs/mid_align.xpm"
#include "./icones_rcs/low_align.xpm"
#include "./icones_rcs/scenery_align.xpm"
#include "./icones_rcs/select_align.xpm"

static gint TmpAlignZone=1;/* selection */
static gint TmpAlignHoriz=0;/* no change */
static gint TmpAlignVerti=0;/* no change */
static gint TmpFps;

/**** fonctions ****/


/*******************************
 * fonctions pour choisir
 * la taille du canevas
 * ****************************/



/************************************
 * préférences
 * *********************************/
 #if 0
void
on_buttonDefautPageColor_clicked       (GtkButton       *button,
                                        GtkWidget *win)
{
	gdouble couleur[4]; /* tableau temporaire pour les composantes */
	GtkColorSelectionDialog *dialog_couleur;
    gint reponse;
    cairo_t *cr; 
	
    cr = gdk_cairo_create(win->window);
    dialog_couleur = (GtkColorSelectionDialog*)gtk_color_selection_dialog_new( gettext("Choice of the page's default color ..."));
    gtk_widget_hide(dialog_couleur->help_button);
    reponse = gtk_dialog_run(GTK_DIALOG(dialog_couleur));
    if (reponse==GTK_RESPONSE_OK)
          {
              /* récupérer la couleur choisie  */
              gtk_color_selection_get_color(GTK_COLOR_SELECTION (dialog_couleur->colorsel),couleur);   
              TmpPgeColor.red=(guint16)(couleur[0]*65535);
              TmpPgeColor.green=(guint16)(couleur[1]*65535);          
              TmpPgeColor.blue=(guint16)(couleur[2]*65535);    
			  /* réafficher la preview */
			  cairo_set_source_rgb(cr,(gdouble)(TmpPgeColor.red/65535.0),
                         (gdouble)(TmpPgeColor.green/65535.0),
						 (gdouble)(TmpPgeColor.blue/65535.0));
			  cairo_rectangle(cr,0,0,32,32);
			  cairo_fill(cr);
			  cairo_set_source_rgb(cr,0,0,0);
              cairo_rectangle(cr,0,0,32,32);
              cairo_stroke(cr);
			  cairo_destroy(cr);        	             
          }
    gtk_widget_destroy(GTK_WIDGET(dialog_couleur));
}

gboolean
on_drawingareaPageDefaultColor_expose_event
                                        (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                       GtkWidget *win)
{
 cairo_t *cr; 
 cr = gdk_cairo_create(win->window);
 
 cairo_set_source_rgb(cr,(gdouble)(TmpPgeColor.red/65535.0),
                         (gdouble)(TmpPgeColor.green/65535.0),
						 (gdouble)(TmpPgeColor.blue/65535.0));
 cairo_rectangle(cr,0,0,32,32);
 cairo_fill(cr);
 cairo_set_source_rgb(cr,0,0,0);
 cairo_rectangle(cr,0,0,32,32);
 cairo_stroke(cr);
 cairo_destroy(cr); 	
 return FALSE;
}
#endif

/************************************
 * importation d'éléments
 * dans la bibliothèque
 * en entrée, un message spécifique,
 * plus un code de format pour les
 * filtres de recherche
 * ********************************/
GtkWidget* dlg_create_dialogImporter(gchar* titre, gint format)
{
  GtkWidget *dialogImporter;
  GtkWidget *dialog_vbox9;
  GtkWidget *button6;
  GtkWidget *button7;
  GtkFileFilter *filter;
  
  filter = gtk_file_filter_new ();

  dialogImporter = gtk_file_chooser_dialog_new (titre, NULL,
                     GTK_FILE_CHOOSER_ACTION_OPEN,NULL,NULL, NULL);
  switch(format)
    {					 
     case 1:/* bitmap */
     {
       gtk_file_filter_add_pattern (filter, "*.jpg");
	   gtk_file_filter_add_pattern (filter, "*.jpeg");
	   gtk_file_filter_add_pattern (filter, "*.png");
	   gtk_file_filter_add_pattern (filter, "*.xpm");
	   gtk_file_filter_set_name (filter,"images");	 
	   break;
     }
     case 2:/* vector drawings */
     {
       gtk_file_filter_add_pattern (filter, "*.svg");	 
	   gtk_file_filter_set_name (filter,gettext( "drawings"));	  
	   break; 
     }
     case 3:/* sound */
     {
       gtk_file_filter_add_pattern (filter, "*.wav");	
	   gtk_file_filter_add_pattern (filter, "*.WAV");
	   gtk_file_filter_add_pattern (filter, "*.mp3");
	   gtk_file_filter_add_pattern (filter, "*.MP3");
	   gtk_file_filter_set_name (filter,gettext( "sounds"));	
	   break;    
     }
     case 4:/* symbols */
     {
       gtk_file_filter_add_pattern (filter, "*.svg");	 
	   gtk_file_filter_set_name (filter,gettext( "symbols"));	
	   break;   
     }	 
	 case 5:/* clips */
     {
       gtk_file_filter_add_pattern (filter, "*.swf");	 
	   gtk_file_filter_set_name (filter,gettext( "clips"));	   
     }
   }/*end switch*/
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(dialogImporter),filter);
  gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(dialogImporter),TRUE);/* multiple selection allowed */
  gtk_container_set_border_width (GTK_CONTAINER (dialogImporter), 5);
  gtk_window_set_position (GTK_WINDOW (dialogImporter), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dialogImporter), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (dialogImporter), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox9 = gtk_dialog_get_content_area(GTK_DIALOG(dialogImporter));
  gtk_widget_show (dialog_vbox9);


  button6 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button6);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogImporter), button6, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_default (button6, TRUE);

  button7 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button7);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialogImporter), button7, GTK_RESPONSE_OK);
  gtk_widget_set_can_default (button7, TRUE);

  gtk_widget_grab_default (button7);
  return dialogImporter;
}
/*************************************
 * renommer un calque
 * **********************************/

GtkWidget* create_dialogRenameLayer(gchar*     nom_calque, 
                                    GtkWidget* entry1RenameLayer)
{
  GtkWidget *dialogRenameLayer;  
  GtkWidget *table1;  
  GtkWidget *label49CurrentLayerName;
  GtkBuilder *builder_dlg;

  builder_dlg = gtk_builder_new();
  gtk_builder_add_from_file(builder_dlg, g_build_filename(ella_get_data_dir(), "ui/dlg_rename_layer.ui", NULL), NULL);
  dialogRenameLayer = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_dialogRenameLayer")); 
  label49CurrentLayerName=GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_label49CurrentLayerName"));
  table1 = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_table1"));  
  /* a trick the entry is created but not yet visible */
  gtk_widget_show (entry1RenameLayer);
  gtk_table_attach (GTK_TABLE (table1), entry1RenameLayer, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_max_length (GTK_ENTRY (entry1RenameLayer), 128);
  gtk_entry_set_invisible_char (GTK_ENTRY (entry1RenameLayer), 9679);

  /* modifiy the current name of selected layer */
  gtk_label_set_text(GTK_LABEL(label49CurrentLayerName),nom_calque); 

  return dialogRenameLayer;
}

/************************************
 * callback du changement nombre 
 * d'images
 * *********************************/
void on_spinbuttonAddFramesAfterCursor_value_changed(GtkSpinButton* spinbutton,
                                                     gint*          val_int)
{
   gint valeur;
   
   /* lire la nouvelle valeur */
   valeur=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton));
   /* poke de la valeur */
   *val_int=valeur;
}

/*************************************
ajouter des images APRES la
position du curseur
*************************************/
GtkWidget* create_dialogAddFramesAfterCursor(gint  position_actuelle,
                                             gint  max_possible,
                                             gint* val_int)
{
  GtkWidget *dialogAddFramesAfterCursor;
  GtkWidget *dialog_vbox13;
  GtkWidget *vbox12;
  GtkWidget *label47AddFramesAfterCursor;
  GObject *spinbuttonAddFramesAfterCursor_adj;
  GtkWidget *spinbuttonAddFramesAfterCursor;

  GtkBuilder *builder_dlg = gtk_builder_new();

  gtk_builder_add_from_file(builder_dlg, g_build_filename(ella_get_data_dir(), "ui/dlg_add_frames_after.ui", NULL), NULL);
  dialogAddFramesAfterCursor=GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_dialogAddFramesAfterCursor")); 
  spinbuttonAddFramesAfterCursor_adj = G_OBJECT(gtk_builder_get_object (builder_dlg, "w_spinbuttonAddFramesAfterCursor_adj")); 
  spinbuttonAddFramesAfterCursor = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_spinbuttonAddFramesAfterCursor")); 
  gtk_adjustment_set_value (GTK_ADJUSTMENT(spinbuttonAddFramesAfterCursor_adj),1);
  gtk_adjustment_set_upper (GTK_ADJUSTMENT(spinbuttonAddFramesAfterCursor_adj), max_possible-position_actuelle);

  g_signal_connect((gpointer) spinbuttonAddFramesAfterCursor, "value_changed",
                            G_CALLBACK (on_spinbuttonAddFramesAfterCursor_value_changed),
                            val_int);
  return dialogAddFramesAfterCursor;
}


/*************************************
 * general error dialog
 * **********************************/
void dlg_file_error(void)
{
    dlg_misc_error(gettext("Error loading file."));
}

/*************************************
 * general error dialog
 * **********************************/
void dlg_misc_error(gchar *msg)
{
  GtkWidget *dialog;
  
  dialog = gtk_message_dialog_new(NULL,
            GTK_DIALOG_DESTROY_WITH_PARENT,
            GTK_MESSAGE_ERROR,
            GTK_BUTTONS_OK,
            (const gchar *)msg);
  gtk_window_set_title(GTK_WINDOW(dialog), gettext("Error"));
  gtk_dialog_run(GTK_DIALOG(dialog));
  gtk_widget_destroy(dialog);
}

/**************************************************
 * callback for movie footage
 * ************************************************/
void on_spinbuttonTrames_changed(GtkEditable* editable, GtkWidget* user_data)
{
  gint valeur;
  
  /* we compute the new duration in seconds */
  valeur=(gint)(gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(editable)) / TmpFps);
  gtk_label_set_text(GTK_LABEL(user_data),g_strdup_printf("%d",valeur));	
}

/**********************************************
 * dialog to change the total length of
 * the movie
 * ******************************************/
GtkWidget* create_dialogFootage(gint fps)
{
  gint valeur;
  GtkWidget *dialogFootage;
  GtkWidget *spinbuttonTrames;
  GtkWidget *labelDuration;
  GObject *spinbuttonTrames_adj;
 
   GtkBuilder *builder_dlg = gtk_builder_new();
   
   TmpFps=fps;
   gtk_builder_add_from_file(builder_dlg, g_build_filename(ella_get_data_dir(), "ui/dlg_footage.ui", NULL), NULL);
   dialogFootage=GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_dialog_footage")); 
   spinbuttonTrames_adj=G_OBJECT(gtk_builder_get_object (builder_dlg, "w_spinbuttonTrames_adj"));  
   gtk_adjustment_set_value (GTK_ADJUSTMENT(spinbuttonTrames_adj),512);
   spinbuttonTrames=GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_spinbuttonTrames")); 
   labelDuration=GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_label_footage_playing_time")); 
   valeur=(gint)(gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbuttonTrames)) / TmpFps);
   gtk_label_set_text(GTK_LABEL(labelDuration),g_strdup_printf("%d",valeur));
  
   g_signal_connect ((gpointer) spinbuttonTrames, "value_changed",
                            G_CALLBACK (on_spinbuttonTrames_changed),
                            (labelDuration));


  return dialogFootage;
}

/**************************************
 * callbacks for alignment dialog
 * ***********************************/
void on_radiobuttonHorizAlign_toggled(GtkToggleButton* togglebutton,
                                      gpointer         user_data)
{
	GSList *pList;	
	gint i=0;
	
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(user_data));
	while(pList)
		{
			if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
				{
					pList = NULL;
					TmpAlignHoriz=i;
				}
			else
				{
					pList = g_slist_next(pList);
					i++;
                }
		}/* wend */		
}										

void on_radiobuttonVertiAlign_toggled(GtkToggleButton* togglebutton,
                                      gpointer         user_data)
{
	GSList *pList;
	gint i=0;
	gboolean trouve=FALSE;
		
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(user_data));
	while(pList)
		{
			if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
				{
					pList = NULL;
					trouve=TRUE;
					TmpAlignVerti=i;
				}
			else
				{
					pList = g_slist_next(pList);
					i++;
                }
		}/* wend */		
}										

void on_radiobuttonZoneAlign_toggled(GtkToggleButton* togglebutton,
                                     gpointer         user_data)
{
	GSList *pList;
	gint i=0;
	gboolean trouve=FALSE;
		
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(user_data));
	while(pList)
		{
			if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
				{
					pList = NULL;
					trouve=TRUE;
					TmpAlignZone=i;
					//printf("le choix actuel est :%d\n",i);
				}
			else
				{
					pList = g_slist_next(pList);
					i++;
                }
		}/* wend */		
}										
								
/* ad-hoc functions to get the choice of user */
gint dlg_get_horizontal_align(void)
{
    return TmpAlignHoriz;
}

gint dlg_get_vertical_align(void)
{
    return TmpAlignVerti;
}

gint dlg_get_zone_align(void)
{
    return TmpAlignZone;
}
										
/*************************************
 * dialog to set alignment of items
 * **********************************/
GtkWidget* create_dialogAlignement(void)
{
  GtkWidget *dialogAlignement;
  GtkWidget *radiobuttonLeftAligne;
  GtkWidget *radiobuttonCenterAlign;
  GtkWidget *radiobuttonRightAlign;
  GtkWidget *radiobuttonNoChangeHoriz;
  GtkWidget *radiobuttonHighAlign;
  GSList *radiobuttonHighAlign_group = NULL;
  GtkWidget *image15;
  GtkWidget *radiobuttonMiddleAlign;
  GtkWidget *image16;
  GtkWidget *radiobuttonLowAlign;
  GtkWidget *radiobuttonNoChangeVerti;
  GtkWidget *image17;
  GtkWidget *radiobuttonSelectionAlign;
  GSList *radiobuttonSelectionAlign_group = NULL;
  GtkWidget *image18;
  GtkWidget *radiobuttonSceneryAlign;
  GtkWidget *image19;
  GdkPixbuf *ico;

  
    GtkBuilder *builder_dlg = gtk_builder_new();
    gtk_builder_add_from_file(builder_dlg, g_build_filename(ella_get_data_dir(), "ui/dialogAlignement.ui", NULL), NULL);   
    dialogAlignement = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_dialogAlignement")); 
  
  radiobuttonLeftAligne = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonLeftAligne"));

  radiobuttonCenterAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonCenterAligne"));  

  radiobuttonRightAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonRightAligne"));
  
  radiobuttonNoChangeHoriz = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonNoChangeHoriz"));

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobuttonNoChangeHoriz),TRUE);
  
  

  radiobuttonHighAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonHighAlign"));
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonHighAlign), radiobuttonHighAlign_group);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonHighAlign));


    ico = gdk_pixbuf_new_from_xpm_data((const char **)high_align_xpm);  
  image15 =  GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_image_high")); 
  gtk_image_set_from_pixbuf(GTK_IMAGE(image15),ico);
  g_object_unref(ico);

  radiobuttonMiddleAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonMiddleAlign"));
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonMiddleAlign), radiobuttonHighAlign_group);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonMiddleAlign));


   ico = gdk_pixbuf_new_from_xpm_data((const char **)mid_align_xpm);  
  image16 =  GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_image_middle")); 
  gtk_image_set_from_pixbuf(GTK_IMAGE(image16),ico);
  g_object_unref(ico);
   

  radiobuttonLowAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonLowAlign"));
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonLowAlign), radiobuttonHighAlign_group);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonLowAlign));

 

    ico = gdk_pixbuf_new_from_xpm_data((const char **)low_align_xpm);  
  image17 =  GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_image_low"));  
  gtk_image_set_from_pixbuf(GTK_IMAGE(image17),ico);
  g_object_unref(ico);
  

  

  radiobuttonNoChangeVerti = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonNoChangeVerti"));
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonNoChangeVerti), radiobuttonHighAlign_group);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiobuttonNoChangeVerti),TRUE);
  radiobuttonHighAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonNoChangeVerti));

 

  radiobuttonSelectionAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonSelectionAlign"));
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonSelectionAlign), radiobuttonSelectionAlign_group);
  radiobuttonSelectionAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonSelectionAlign));

 

    ico = gdk_pixbuf_new_from_xpm_data((const char **)select_align_xpm);  
  image18 =   GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_image_selection"));  
  gtk_image_set_from_pixbuf(GTK_IMAGE(image18),ico);
  g_object_unref(ico);
 

  radiobuttonSceneryAlign = GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_radiobuttonSceneryAlign"));
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobuttonSceneryAlign), radiobuttonSelectionAlign_group);
  radiobuttonSelectionAlign_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobuttonSceneryAlign));

 

   ico = gdk_pixbuf_new_from_xpm_data((const char **)scenery_align_xpm);  
  image19 =  GTK_WIDGET(gtk_builder_get_object (builder_dlg, "w_image_scenery")); 
  gtk_image_set_from_pixbuf(GTK_IMAGE(image19),ico);
  g_object_unref(ico);
 
    gtk_builder_connect_signals (builder_dlg, NULL);

  g_signal_connect ((gpointer) radiobuttonHighAlign, "toggled",
                            G_CALLBACK (on_radiobuttonVertiAlign_toggled),
                             (radiobuttonHighAlign));
  g_signal_connect ((gpointer) radiobuttonMiddleAlign, "toggled",
                            G_CALLBACK (on_radiobuttonVertiAlign_toggled),
                             (radiobuttonHighAlign));
  g_signal_connect ((gpointer) radiobuttonLowAlign, "toggled",
                            G_CALLBACK (on_radiobuttonVertiAlign_toggled),
                             (radiobuttonHighAlign));
  g_signal_connect ((gpointer) radiobuttonSelectionAlign, "toggled",
                            G_CALLBACK (on_radiobuttonZoneAlign_toggled),
                             (radiobuttonSelectionAlign));
  g_signal_connect ((gpointer) radiobuttonSceneryAlign, "toggled",
                            G_CALLBACK (on_radiobuttonZoneAlign_toggled),
                             (radiobuttonSelectionAlign));
  return dialogAlignement;
}


/***********************************
 dialogue de sauvegarde
***********************************/

GtkWidget *create_file_save_dialog (void)
{
  GtkWidget *file_save_dialog;
  GtkWidget *button10;
  GtkWidget *button11;

  GtkFileFilter *filter = gtk_file_filter_new ();
  gtk_file_filter_add_pattern (filter, "*.esvg");
  gtk_file_filter_set_name (filter,"Ella SVG");

  file_save_dialog = gtk_file_chooser_dialog_new(gettext("Save as..."), NULL,
             GTK_FILE_CHOOSER_ACTION_SAVE,NULL,NULL, NULL);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(file_save_dialog),filter);
  gtk_container_set_border_width (GTK_CONTAINER (file_save_dialog), 5);
  gtk_window_set_position (GTK_WINDOW (file_save_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (file_save_dialog), TRUE);
  gtk_window_set_icon_name (GTK_WINDOW (file_save_dialog), "gtk-save");
  gtk_window_set_type_hint (GTK_WINDOW (file_save_dialog), GDK_WINDOW_TYPE_HINT_DIALOG);



  button10 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button10);
  gtk_dialog_add_action_widget (GTK_DIALOG (file_save_dialog), button10, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_default(button10, TRUE);

  button11 = gtk_button_new_from_stock ("gtk-save");
  gtk_widget_show (button11);
  gtk_dialog_add_action_widget (GTK_DIALOG (file_save_dialog), button11, GTK_RESPONSE_OK);
  gtk_widget_set_can_default(button11, TRUE);
  gtk_widget_grab_default (button11);
  return file_save_dialog;
}
/********************************
 File Dialog item
 ********************************/
 GtkWidget *create_DialogOpenFile (gchar* titre, const gchar* filtre1,
                                   gchar* filtre2,gchar* filtre3)
{
  GtkWidget *DialogOpenFile;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkFileFilter *filter = gtk_file_filter_new ();

  DialogOpenFile = gtk_file_chooser_dialog_new ("Ouvrir ...", NULL,
               GTK_FILE_CHOOSER_ACTION_OPEN,NULL,NULL, NULL);
  if (filtre1!=NULL)
  gtk_file_filter_add_pattern (filter, filtre1);
  if (filtre2!=NULL)
    gtk_file_filter_add_pattern (filter, filtre2);
  if (filtre3!=NULL)
    gtk_file_filter_add_pattern (filter, filtre3);
  gtk_file_filter_set_name (filter, filtre1);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(DialogOpenFile),filter);

  gtk_container_set_border_width (GTK_CONTAINER (DialogOpenFile), 5);
  gtk_window_set_position (GTK_WINDOW (DialogOpenFile), GTK_WIN_POS_CENTER);
  gtk_window_set_type_hint (GTK_WINDOW (DialogOpenFile), GDK_WINDOW_TYPE_HINT_DIALOG);
gtk_window_set_icon_name (GTK_WINDOW (DialogOpenFile), "gtk-open");


  button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (DialogOpenFile), button1, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_default(button1, TRUE);

  button2 = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (DialogOpenFile), button2, GTK_RESPONSE_OK);
  gtk_widget_set_can_default(button2, TRUE);

  g_signal_connect ((gpointer) DialogOpenFile, "destroy",
                    G_CALLBACK (gtk_widget_destroy),
                    NULL);
  g_signal_connect ((gpointer) button1, "clicked",
                    G_CALLBACK (gtk_true),
                    NULL);

  gtk_widget_grab_default (button2);
  return DialogOpenFile;
}
/********************************
 Export Dialog item
 ********************************/
GtkWidget* create_DialogExportFile(gchar* titre, const gchar* filtre1,
                                   gchar* filtre2, gchar* filtre3)
{
  GtkWidget *DialogExportFile;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkFileFilter *filter = gtk_file_filter_new ();

  DialogExportFile = gtk_file_chooser_dialog_new ("Exporter ...", NULL,
            GTK_FILE_CHOOSER_ACTION_SAVE,NULL,NULL, NULL);
  if (filtre1!=NULL)
  gtk_file_filter_add_pattern (filter, filtre1);
  if (filtre2!=NULL)
    gtk_file_filter_add_pattern (filter, filtre2);
  if (filtre3!=NULL)
    gtk_file_filter_add_pattern (filter, filtre3);
  gtk_file_filter_set_name (filter,"exporter");
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(DialogExportFile),filter);

  gtk_container_set_border_width (GTK_CONTAINER (DialogExportFile), 5);
  gtk_window_set_position (GTK_WINDOW (DialogExportFile), GTK_WIN_POS_CENTER);
  gtk_window_set_type_hint (GTK_WINDOW (DialogExportFile), GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_window_set_icon_name (GTK_WINDOW (DialogExportFile), "gtk-save");


  button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (DialogExportFile), button1, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_default(button1, TRUE);

  button2 = gtk_button_new_from_stock ("gtk-save");
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (DialogExportFile), button2, GTK_RESPONSE_OK);
  gtk_widget_set_can_default(button2, TRUE);

  g_signal_connect ((gpointer) DialogExportFile, "destroy",
                    G_CALLBACK (gtk_widget_destroy),
                    NULL);
  g_signal_connect ((gpointer) button1, "clicked",
                    G_CALLBACK (gtk_true),
                    NULL);

  gtk_widget_grab_default (button2);
  return DialogExportFile;
}
