/* Copyright (C) 2010 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#include "dialogs/misc.h"

void on_ask_before_quit_value_changed(GtkToggleButton* check, gpointer user_data)
{
    ella_config_set_value_int("DONT_ASK_BEFORE_QUIT", gtk_toggle_button_get_active(check));
}

gint dialog_ask_before_quit(void)
{
    if(ella_config_get_value_int("DONT_ASK_BEFORE_QUIT") == FALSE)
    {
        return GTK_RESPONSE_OK;
    }
    else
    {
        GtkWidget* dialog;
        gint reponse;

        GtkBuilder* builder = gtk_builder_new();

        gtk_builder_add_from_file(builder, g_build_filename(ella_get_data_dir(), "ui/dlg_ask_quit.ui", NULL), NULL);
        dialog = GTK_WIDGET(gtk_builder_get_object(builder, "w_dialog_ask_quit"));
        gtk_builder_connect_signals (builder, NULL);

        reponse = gtk_dialog_run(GTK_DIALOG(dialog));
    
        gtk_widget_destroy(dialog);	
        return reponse;
    }
}