/*
copyright 2010 Lucas Baudin <xapantu@gmail.com>
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef H_PREFERENCES_20101130
#define H_PREFERENCES_20101130

#include "callbacks.h"
#include "ella-user_config.h"

/** This function is used to load a dialog from the glade file, since it is the
 * settings dialog, you need to send some default properties: the width of the
 * drawing, it height, it margins, the default fps value, the fottage (FIXME :
 * it is useless ?!), the background_color, a boolean to say if the library is
 * saved in the archive, and the default timeline zoom.
 * It returns a pointer of the dialog. */
GtkWidget* create_dialogPrefs (gint w, gint h,gint marges, gint fps,
                               gint footage, GdkColor pcolor,gboolean f_archive,
                               gint zoom);

/** This function shoudn't be used in external files, it is used to handle 
 * the gtk_spinbutton where the user can choose the default drawing height. */
void on_entryHeight_changed(GtkWidget* entry, gpointer user_data);

/** This function shoudn't be used in external files, it is used to handle 
 * the gtk_spinbutton where the user can choose the default drawing width. */
void on_entryWidth_changed(GtkWidget* entry, gpointer user_data);

/** This function shoudn't be used in external files, it is used to handle 
 * the gtk_spinbutton where the user can choose the default drawing margins. */
void on_entryMargins_changed(GtkWidget* entry, gpointer user_data);

/** This function shoudn't be used in external files, it is used to handle 
 * the gtk_combobox where the user can choose the default timeline zoom. */
void on_combobox1PrefsZoom_changed(GtkComboBox* combobox, gpointer user_data);

/** This function shoudn't be used in external files, it is used to handle 
 * the checkbox where the user can choose if the media will be saved in the
 * archive (the Ella's file). */
void on_checkbuttonArchiveBiblioAuto_toggled(GtkToggleButton* togglebutton,
                                             gpointer user_data);
/** FIXME: this function doesn't work?! */
void on_spinbuttonFootage_changed(GtkWidget* spb, gpointer user_data);

/** This function shoudn't be used in external files, it is used to handle 
 * the gtk_spinbutton where the user can choose the default FPS. */
void on_spinbuttonDefaultFPS_changed(GtkWidget* spb, gpointer user_data);

void on_color_changed(GtkColorSelection* colorselection, gpointer user_data);

void settings_on_ask_before_quit_value_changed(GtkToggleButton* check, gpointer user_data);
#endif
