/* Copyright (C) 2011 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#include "editor/editor_callbacks.h"
#include "items/image.h"



void
on_checkbuttonEditorAttractionMagnetic_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gboolean etat;
	
	etat=gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(togglebutton));
	fAutoPlacement=etat;
}

/******************************************
 * 2 callbacks for expose events of
 * notification zone of editor
 * ***************************************/
void editor_react_notification_area_fillcolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data)
{
  cairo_t *cr1;
     
	  
  cr1 = gdk_cairo_create(gtk_widget_get_window(widget));	
  cairo_set_source_rgb(cr1,(gdouble)(FillColor.red/65535.0),
                         (gdouble)(FillColor.green/65535.0),
						 (gdouble)(FillColor.blue/65535.0));
  cairo_paint(cr1);
  cairo_destroy(cr1);
}					
void editor_react_notification_area_strokecolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data)
{
  cairo_t *cr1;
  	  
  cr1 = gdk_cairo_create(gtk_widget_get_window(widget));	
  cairo_set_source_rgb(cr1,(gdouble)(PenColor.red/65535.0),
                         (gdouble)(PenColor.green/65535.0),
						 (gdouble)(PenColor.blue/65535.0));
  cairo_paint(cr1);
  cairo_destroy(cr1);	
}
void editor_react_styles_area_strokecolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data)
{
	cairo_t *cr_cont;
	gint r_cont,v_cont,b_cont,a_cont;	
	GtkWidget *spb_rc;
	GtkWidget *spb_bc;
	GtkWidget *spb_vc;
	GtkWidget *spb_ac;
	GtkWidget *area_cont;
	
	spb_rc=user_data[4];
	spb_vc=user_data[5];
	spb_bc=user_data[6];
	spb_ac=user_data[7];	
	area_cont=user_data[9];	
    cr_cont = gdk_cairo_create(gtk_widget_get_window(area_cont));
	r_cont=gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(spb_rc));
	v_cont=gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(spb_vc));
	b_cont=gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(spb_bc));
	a_cont=gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(spb_ac));
    cairo_set_source_rgba(cr_cont, (gdouble)(r_cont/255.0),
                          (gdouble)(v_cont/255.0),
                          (gdouble)(b_cont/255.0),
						  (gdouble)(a_cont/100.0));
    cairo_paint(cr_cont);	
	cairo_destroy(cr_cont);
}
/***********************************************
 * réactions aux changements dans les éléments
 * (gtkentries) de la partie 'style' de l'onglet
 * 'propriétés' ; appelé par la fonction 
 * callback de chaque élément ;
 * le paramètre est une "structure de pointeurs"
 * *********************************************/
void editor_react_properties_styles_entries(GtkEditable     *editable,
											gpointer *user_data)
{
	gdouble ep_trait;
	gdouble r_rempli,v_rempli,b_rempli,a_rempli;
	gdouble r_cont,v_cont,b_cont,a_cont;
	GtkWidget *spb_ep_trait;
	GtkWidget *spb_rr;
	GtkWidget *spb_br;
	GtkWidget *spb_vr;
	GtkWidget *spb_rc;
	GtkWidget *spb_bc;
	GtkWidget *spb_vc;
	GtkWidget *spb_ar;
	GtkWidget *spb_ac;
	GtkWidget *button_annul;
    EllaColorSelection* ecs_fill, * ecs_stroke;

	
    if (NbCallsToReject>=0)
    {
        NbCallsToReject--;
        return;
    }

	/* passage des pointeurs depuis la structure */
	spb_rr=user_data[0];
	spb_vr=user_data[1];
	spb_br=user_data[2];
	spb_ar=user_data[3];
	spb_rc=user_data[4];
	spb_vc=user_data[5];
	spb_bc=user_data[6];
	spb_ac=user_data[7];
	spb_ep_trait=user_data[10];
    button_annul=user_data[11];
    ecs_fill=user_data[13];
    ecs_stroke=user_data[14];
	
	/* lire les valeurs */
	r_rempli    = (double)ella_color_selection_get_value(ecs_fill)->red/0xFFFF;
	v_rempli    = (double)ella_color_selection_get_value(ecs_fill)->green/0xFFFF;
	b_rempli    = (double)ella_color_selection_get_value(ecs_fill)->blue/0xFFFF;
	a_rempli    = (double)ella_color_selection_get_value_alpha(ecs_fill)/100.0;
	r_cont      = (double)ella_color_selection_get_value(ecs_stroke)->red/0xFFFF;
	v_cont      = (double)ella_color_selection_get_value(ecs_stroke)->green/0xFFFF;
	b_cont      = (double)ella_color_selection_get_value(ecs_stroke)->blue/0xFFFF;
	a_cont      = (double)ella_color_selection_get_value_alpha(ecs_stroke)/100.0;
	ep_trait=gtk_spin_button_get_value(GTK_SPIN_BUTTON(spb_ep_trait));
	ella_canvas_set_selection_line_width(canvas, ep_trait);
	/* transmettre les valeurs aux objets */
    ella_canvas_set_selection_color(canvas, r_rempli, v_rempli, b_rempli, a_rempli);
    ella_canvas_set_selection_stroke_color(canvas, r_cont, v_cont, b_cont, a_cont);
}


/*****************************************
 * réaction à un appel de 'callback' de
 * l'onglet 'propriétés'
 * limité aux entries de position et
 * dimensions ; on passe en paramètre le
 * n° du champ concerné
 * **************************************/
void editor_react_properties_entries(GtkEditable *editable, gint champ)
{
}

/*******************************
 * ad hoc function to get a 
 * valid font description
 * for selected items
 * *********************************/
gchar *editor_get_valide_font_desc(GList* list)
{
}
/**********************************
 * fonction de callback du choix 
 * du style du texte
 * *******************************/
gboolean cb_style_texte(GtkWidget *pBtn, gpointer data)
{
} 
/**********************************
 * fonction callback :
 * en entrée, le pointeur sur le
 * radiobutton, et le n° du
 * bouton
 * très important : les seules
 * macros admises sont les
 * "classiques" et non pas
 * les spécifiques avec _tool !!
 * *******************************/

gboolean cb_toolbar_toggled(GtkWidget *pBtn, gpointer data)
{
	GSList *pList;
	gint count;	

	/* clear cursor if we are among one of the drawing modes */
    if(EditorMode==EDITOR_MODE_BOX || EditorMode==EDITOR_MODE_CIRCLE ||
    EditorMode==EDITOR_MODE_TEXT ||
    EditorMode==EDITOR_MODE_LINE ||
    EditorMode==EDITOR_MODE_PATH ||
    EditorMode==EDITOR_MODE_IMAGE
    )
    {
        SelectedArea=FALSE;
        cursor_normal(GTK_WIDGET(canvas));
    }
	/* Recuperation de la liste des boutons */
    pList = gtk_radio_tool_button_get_group(GTK_RADIO_TOOL_BUTTON(data));
    /* Parcours de la liste */
    count = 5;
    while(pList)
      { /* Le bouton est il selectionne */
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
         {                        
            /* On met la liste a NULL pour sortir de la boucle */
            pList = NULL;
         }
        else
         {  /* NON -> on passe au bouton suivant */
            pList = g_slist_next(pList);
            count--;
         }
      }

    switch (count)
    {
    case 1:
        EditorMode=EDITOR_MODE_SELECT;
        break;
    case 2:
        EditorMode=EDITOR_MODE_PATH;
        break;
    case 3:
        EditorMode=EDITOR_MODE_BOX;
        break;
    case 4:
        EditorMode=EDITOR_MODE_CIRCLE;
        break;
    case 5:
        EditorMode=EDITOR_MODE_TEXT;
        break;
    default:
        break;
    }

    if(EditorMode==EDITOR_MODE_LINE)
    {
        ella_canvas_set_tool(canvas, ELLA_TOOL_LINE);
        cursor_line(GTK_WIDGET(canvas));
    }
    if (EditorMode==EDITOR_MODE_PATH)
    {
        ella_canvas_set_tool(canvas, ELLA_TOOL_PATH);
        cursor_path(GTK_WIDGET(canvas));
    }
    if (EditorMode==EDITOR_MODE_TEXT)
    {
        ella_canvas_set_tool(canvas, ELLA_TOOL_TEXT);
        cursor_text(GTK_WIDGET(canvas));
    }
    if (EditorMode==EDITOR_MODE_CIRCLE)
    {
        ella_canvas_set_tool(canvas, ELLA_TOOL_CIRCLE);
        cursor_circle(GTK_WIDGET(canvas));
    }
    if (EditorMode==EDITOR_MODE_IMAGE)
    {
        cursor_image(GTK_WIDGET(canvas));
    }	 
    if (EditorMode==EDITOR_MODE_BOX)
    {
        ella_canvas_set_tool(canvas, ELLA_TOOL_RECTANGLE);
        cursor_box(GTK_WIDGET(canvas));
    }
    if (EditorMode==EDITOR_MODE_SELECT)
    {
        ella_canvas_set_tool(canvas, ELLA_TOOL_SELECT);
    }
   return TRUE;	 
}
/************************
 * supprimer le groupe
 * d'objets sélectionnés.
 * Attention :pas
 * d'annulation possible
 * **********************/
void cb_menu_editor_delete(GSList *selection)
{
}
/**************/
void cb_menu_style_dash (GtkWidget *p_widget, gpointer user_data)
{
}
void cb_menu_object_up (GtkWidget *p_widget, gpointer user_data)
{
	editor_raise(pSelectedItemsList);
}
void cb_menu_object_down (GtkWidget *p_widget, gpointer user_data)
{
	editor_lower(pSelectedItemsList);
}
void cb_menu_object_group (GtkWidget *p_widget, gpointer user_data)
{
}
void cb_menu_object_ungroup (GtkWidget *p_widget, gpointer user_data)
{
}
void cb_menu_object_align (GtkWidget *p_widget, gpointer user_data)
{
    GtkWidget *dlg;
    gint reponse, h_align,v_align,z_align;

    dlg = create_dialogAlignement();
    reponse = gtk_dialog_run(GTK_DIALOG(dlg)); 
    gtk_widget_destroy(dlg);
    if (reponse != 0)/* 0=cancel */
    {
        h_align = dlg_get_horizontal_align();
        v_align = dlg_get_vertical_align();
        z_align = dlg_get_zone_align();
    }   	
}

/**********************************
 * fonction de callback du choix 
 * de la couleur du fond de page
 * *******************************/
gboolean cb_menu_color_page(GtkWidget *pBtn, gpointer data)
{
	gchar *choix;
	gboolean retour;
	
	choix=dlg_couleur(DLGEDITEUR_COLORPAGE_TITLE);
    return TRUE;
}
/*********************************
 * choix de la fonte
 * *******************************/
void cb_menu_font_select(GtkWidget *p_widget, gpointer user_data)
{

}

void cb_menu_editor_paste (GtkWidget *p_widget, GdkEventButton *event)
{
}
void cb_menu_editor_copy (GtkWidget *p_widget, gpointer user_data)
{
}

void cb_menu_editor_cut (GtkWidget *p_widget, gpointer user_data)
{
}

