/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef H_EDITOR_CALLBACKS_20101130
#define H_EDITOR_CALLBACKS_20101130

/* translations */
#include <locale.h>
#include <libintl.h>

#include <math.h>

#include <gdk/gdkkeysyms.h>

#include "dialogs/dialogs_editor.h"
#include "dialogs/dlgdivers.h"
#include "clipboard.h"
#include "timeline.h"
#include "editor/editor.h"
#include "cursor.h"
#include "interface_editor.h"
#include "ella-math.h"
#include "ella-color_selection.h"

void on_checkbuttonEditorAttractionMagnetic_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void editor_react_notification_area_fillcolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data);
void editor_react_notification_area_strokecolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data);
void editor_react_properties_styles_entries(GtkEditable     *editable,
											gpointer *user_data);
void editor_react_styles_area_fillcolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data);
void editor_react_styles_area_strokecolor_expose_event(GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         *user_data);
void editor_react_properties_styles_entries(GtkEditable     *editable,
											gpointer *user_data);
                                            
void editor_react_properties_entries(GtkEditable *editable, gint champ);
gboolean
on_editor_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        GtkWidget *win);

gboolean cb_color_trace(GtkWidget *pBtn, gpointer data);
gboolean cb_style_texte(GtkWidget *pBtn, gpointer data);
gboolean cb_toolbar_toggled(GtkWidget *pBtn, gpointer data);
void cb_menu_editor_delete(GSList *selection);
void cb_menu_style_dash (GtkWidget *p_widget, gpointer user_data);
void cb_menu_object_up (GtkWidget *p_widget, gpointer user_data);
void cb_menu_object_down (GtkWidget *p_widget, gpointer user_data);
void cb_menu_object_group (GtkWidget *p_widget, gpointer user_data);
void cb_menu_object_ungroup (GtkWidget *p_widget, gpointer user_data);
gboolean cb_text_edit(GtkWidget *p_widget, gpointer user_data);
gboolean cb_menu_color_page(GtkWidget *pBtn, gpointer data);
gboolean cb_menu_color_foreground (GtkWidget *p_widget, gpointer user_data);
void cb_menu_font_select(GtkWidget *p_widget, gpointer user_data);
gboolean on_editor_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        GtkWidget *win);
void cb_menu_editor_paste (GtkWidget *p_widget, GdkEventButton *event);
void cb_menu_editor_copy (GtkWidget *p_widget, gpointer user_data);
void cb_menu_editor_cut (GtkWidget *p_widget, gpointer user_data);

void cb_menu_object_align (GtkWidget *p_widget, gpointer user_data);
#endif
