/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ella.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "interface.h"
#include "ella-fonts.h"
/***************************
 * icones de certains menus
 **************************/
#include "./icones_rcs/remove_interpola16x16.xpm"
#include "./icones_rcs/set_keyframe_to_blank.xpm"
#include "./icones_rcs/remove_frames_to_cursor.xpm"
#include "./icones_rcs/remove_frames_from_cursor.xpm"
#include "./icones_rcs/add_frames_from_cursor.xpm"
#include "./icones_rcs/remove_keyframe.xpm"
#include "./icones_rcs/remove_selection16x16.xpm"
#include "./icones_rcs/add_frames_to_cursor.xpm"
#include "./icones_rcs/new_keyframe.xpm"
#include "./icones_rcs/new_blank_keyframe.xpm"
#include "./icones_rcs/interpola16x16.xpm"
#include "./icones_rcs/layer_rename_16x16.xpm"
#include "./icones_rcs/select_all.xpm"
#include "./icones_rcs/deselect_all.xpm"
#include "./icones_rcs/duplicate_item_16x16.xpm"
#include "./icones_rcs/layer_delete_16x16.xpm"
#include "./icones_rcs/rotate.xpm"

static gchar** path_file = NULL;

EllaUndoManager* undo_manager;
static GOptionEntry entries[] =
{
  { G_OPTION_REMAINING, 0, 0, G_OPTION_ARG_STRING_ARRAY, &path_file, "A file to load", "[File]" },
  { NULL }
};

/* main window geometry */
static gint x_fen,y_fen,w_fen,h_fen;

GtkBuilder* ella_main_builder;

/****************************/
GtkBuilder* create_window_ella (void)
{
    GtkWidget *window_ella;
    /* files */
    GtkWidget *quitter1;
    /* edit */
    GtkWidget *menu_edit;
    /* layers */
    GtkWidget *renommer_calque1;
    GtkWidget *ImgLayerRename;
    GtkWidget *imageSupprimerCalque;
    /* objects */
    GtkWidget *dupliquer1;
    GtkWidget *ImgDupliquer;
    GtkWidget *monter;
    GtkWidget *descendre;
    GtkWidget *rotation1;
    GtkWidget *Imgrotation1;  
    GtkWidget *_90sens_horaire1;
    GtkWidget *_90_anti_horaire1; 
    GtkWidget *_180_sens_horaire1;
    GtkWidget *_270_sens_horaire1;   
    GtkWidget *align_items1;
    GtkWidget *tout_selectionner1;
    GtkWidget *ImgToutSelectionner;
    GtkWidget *deselectionner_tout1;
    GtkWidget *supprimer1;
    /* images-frames */
    GtkWidget *trames1;
    GtkWidget *trames1_menu;
    GtkWidget *inserer_trames;
    GtkWidget *AddFramesToCursor;
    GtkWidget *ajouter_apres_la_position_courante1;
    GtkWidget *ImgAddFromCursor;
    GtkWidget *supprimer2;
    GtkWidget *ImgRemoveToCursor;
    GtkWidget *supprimer_apres_la_position_courante1;
    GtkWidget *ImgRemoveAfterCursor;
    GtkWidget *supprimer_les_trames_selectionnees1;
    GtkWidget *ImgRemoveSelectedFrames;
    GtkWidget *poser_une_image_cle1;
    GtkWidget *ImgNewKeyframe;
    GtkWidget *poser_une_image_cle_vide1;
    GtkWidget *ImgNewBlankKeyframe;
    GtkWidget *creer_une_interpolation_de_mouvement1;
    GtkWidget *ImgNewInterpola;
    GtkWidget *retirer_une_image_cle1;
    GtkWidget *ImgRemoveKeyframe;
    GtkWidget *mettre_a_blanc_image_cle1;
    GtkWidget *imageSetKeyframeToBlank;
    /* format */
    GtkWidget *taille1;
    GtkWidget *couleur_de_la_page1;
    GtkWidget *format_animation1;
    GtkWidget *visualisation;
    GtkWidget *visualisation_menu;
    GtkWidget *jouer_animation1;
    GtkWidget *editeur_zoom_avant;
    GtkWidget *editeur_zoom_arriere;
    GtkWidget *a_propos1;
    /* horizontal toolbar */
    GtkWidget *buttonNew; 
    GtkWidget *buttonSave;
    GtkWidget *buttonCopy;
    GtkWidget *buttonPaste;
    GtkWidget *buttonCut;
    GtkWidget *buttonUndo;
    GtkWidget *buttonRedo;
    GtkWidget *hbox1;
    /* editor */
    GtkWidget *HandleBoxEditor;
    GtkWidget *notebook1;
    GtkWidget *ScrolledWindowEditor;
    GtkWidget *label51EditorCouleurPP;
    GtkWidget *drawingarea1EditorCouleurPP;
    GtkWidget *label52CouleurAP;
    GtkWidget *comboBoxZoom;
    GtkWidget *drawingarea2CouleurAP; 
    GtkWidget *labelEditorMousePosition;  
    GtkWidget *labelEditorHelp;  
    /* player */
    GtkAccelGroup *accel_group;
    /* notebook2 : properties etc. */
    /* properties panel */
    /* part 'styles' of properties */
    GtkWidget *tablePropertiesColors;
    GtkWidget *spinbuttonPropertiesLineWidth;
    GtkWidget *labelTitreCouleursProperties;
    /* end of transitions */
    /* library panel */
    GtkWidget *scrolledwindowBiblio;
    GtkWidget *buttonBiblioArchive;
    GtkWidget *buttonBiblioOpenArchive;
    GtkWidget *buttonBiblioRemove;
 
    /* multi purposes object for pixmaps */
    GdkPixbuf *ico; 
    /* builders */
    GtkBuilder * builder = gtk_builder_new();  
    builder_dlg = NULL;

    accel_group = gtk_accel_group_new ();

    gtk_builder_add_from_file(builder,
                              g_build_filename(ella_get_data_dir(),
                                               "/ui/main.ui",
                                               NULL),
                              NULL);
    window_ella = GTK_WIDGET(gtk_builder_get_object (builder, "window_ella"));

    /* menus recent files */
    GtkRecentFilter* recent_filter = gtk_recent_filter_new();
    GtkWidget* recent_menu = GTK_WIDGET(gtk_builder_get_object(builder, "recentchoosermenu1"));
    gtk_recent_filter_add_pattern(recent_filter, "*.esvg");
    gtk_recent_chooser_set_filter(GTK_RECENT_CHOOSER(recent_menu), recent_filter);

    /* We need to get it from the builder, since we send data_geo to the callback. */
    quitter1 = GTK_WIDGET(gtk_builder_get_object (builder, "file_quit"));

    /* Edit menu. */
    /* Needed, since we sent a custom pointer to the callback. */
    menu_edit = GTK_WIDGET(gtk_builder_get_object (builder, "menuitem_edit1"));
    /* menus layers */
    renommer_calque1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_renommer_calque1"));
    ico = gdk_pixbuf_new_from_xpm_data((const char **)layer_rename_16x16_xpm); 
    ImgLayerRename = gtk_image_new_from_pixbuf(ico);
    g_object_unref(ico);  
    gtk_widget_show (ImgLayerRename);
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (renommer_calque1), ImgLayerRename);
    ico = gdk_pixbuf_new_from_xpm_data((const char **)layer_delete_16x16_xpm); 
    imageSupprimerCalque = gtk_image_new_from_pixbuf(ico);
    g_object_unref(ico);  
    gtk_widget_show (imageSupprimerCalque);
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (gtk_builder_get_object (builder, "w_supprimer_calque1")), imageSupprimerCalque);

    /* menus objects - items */

    dupliquer1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_dupliquer1"));  
    ico = gdk_pixbuf_new_from_xpm_data((const char **)duplicate_item_16x16_xpm); 
    ImgDupliquer = gtk_image_new_from_pixbuf(ico);
    g_object_unref(ico);  
    gtk_widget_show (ImgDupliquer);
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (dupliquer1), ImgDupliquer);
    monter = GTK_WIDGET(gtk_builder_get_object (builder, "w_monter"));  
    gtk_widget_add_accelerator (monter, "activate", accel_group,
                              GDK_KEY_G, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
    descendre = GTK_WIDGET(gtk_builder_get_object (builder, "w_descendre")); 
    gtk_widget_add_accelerator (descendre, "activate", accel_group,
                              GDK_KEY_U, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  rotation1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_rotation1")); 
  ico = gdk_pixbuf_new_from_xpm_data((const char **)rotate_xpm); 
  Imgrotation1 = gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);  
  gtk_widget_show (Imgrotation1);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (rotation1), Imgrotation1);
  _90sens_horaire1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_90sens_horaire1"));
  _90_anti_horaire1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_90_anti_horaire1")); 
  _180_sens_horaire1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_180_sens_horaire1"));
  _270_sens_horaire1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_270_sens_horaire1"));  
  align_items1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_align_items1"));  
  tout_selectionner1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_tout_selectionner1"));  
  gtk_widget_add_accelerator (tout_selectionner1, "activate", accel_group,
                              GDK_KEY_A, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  ico = gdk_pixbuf_new_from_xpm_data((const char **)select_all_xpm); 
  ImgToutSelectionner = gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico);  
  gtk_widget_show (ImgToutSelectionner);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (tout_selectionner1), ImgToutSelectionner);
  deselectionner_tout1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_deselectionner_tout1"));    
  gtk_widget_add_accelerator (deselectionner_tout1, "activate", accel_group,
                              GDK_KEY_A, (GdkModifierType) GDK_CONTROL_MASK | GDK_SHIFT_MASK,
                              GTK_ACCEL_VISIBLE);
  ico = gdk_pixbuf_new_from_xpm_data((const char **)deselect_all_xpm);  
  GtkWidget *ImgDeselectionnerTout = gtk_image_new_from_pixbuf(ico);
  g_object_unref(ico); 
  gtk_widget_show (ImgDeselectionnerTout);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (deselectionner_tout1), ImgDeselectionnerTout);  
  supprimer1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_supprimer1"));    
  gtk_widget_add_accelerator (supprimer1, "activate", accel_group,
                              GDK_KEY_Delete, (GdkModifierType) 0,
                              GTK_ACCEL_VISIBLE);
 
/* menu images-frames */
  trames1 = GTK_WIDGET(gtk_builder_get_object (builder, "menuitem_image1"));
  trames1_menu = GTK_WIDGET(gtk_builder_get_object (builder, "menuitem_image"));
  inserer_trames =  GTK_WIDGET(gtk_builder_get_object (builder, "w_inserer_trames")); 
  gtk_widget_add_accelerator (inserer_trames, "activate", accel_group,
                              GDK_KEY_F5, (GdkModifierType) 0,
                              GTK_ACCEL_VISIBLE);
  ico=gdk_pixbuf_new_from_xpm_data((const char **)add_frames_to_cursor_xpm);							  
  AddFramesToCursor = gtk_image_new_from_pixbuf(ico); 
  gtk_widget_show (AddFramesToCursor);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (inserer_trames), AddFramesToCursor);
  ajouter_apres_la_position_courante1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_ajouter_apres_la_position_courante1"));   
  ico=gdk_pixbuf_new_from_xpm_data((const char **)add_frames_from_cursor_xpm);
  ImgAddFromCursor = gtk_image_new_from_pixbuf(ico);
  gtk_widget_show (ImgAddFromCursor);
  g_object_unref(ico);  
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (ajouter_apres_la_position_courante1), ImgAddFromCursor);
  supprimer2 = GTK_WIDGET(gtk_builder_get_object (builder, "w_supprimer2"));   
  ico=gdk_pixbuf_new_from_xpm_data((const char **)remove_frames_to_cursor_xpm);
  ImgRemoveToCursor = gtk_image_new_from_pixbuf(ico); 
  gtk_widget_show (ImgRemoveToCursor);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (supprimer2), ImgRemoveToCursor);
  supprimer_apres_la_position_courante1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_supprimer_apres_la_position_courante1"));     
  ico=gdk_pixbuf_new_from_xpm_data((const char **)remove_frames_from_cursor_xpm);
  ImgRemoveAfterCursor = gtk_image_new_from_pixbuf(ico); 
  gtk_widget_show (ImgRemoveAfterCursor);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (supprimer_apres_la_position_courante1), ImgRemoveAfterCursor);
  supprimer_les_trames_selectionnees1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_supprimer_les_trames_selectionnees1"));   
  ico = gdk_pixbuf_new_from_xpm_data((const char **)remove_selection16x16_xpm);
  ImgRemoveSelectedFrames = gtk_image_new_from_pixbuf(ico); 
  gtk_widget_show (ImgRemoveSelectedFrames);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (supprimer_les_trames_selectionnees1), ImgRemoveSelectedFrames);  
  poser_une_image_cle1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_poser_une_image_cle1")); 
  gtk_widget_add_accelerator (poser_une_image_cle1, "activate", accel_group,
                              GDK_KEY_F6, (GdkModifierType) 0,
                              GTK_ACCEL_VISIBLE);
  ico = gdk_pixbuf_new_from_xpm_data((const char **)new_keyframe_xpm);
  ImgNewKeyframe = gtk_image_new_from_pixbuf(ico); 
  gtk_widget_show (ImgNewKeyframe);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (poser_une_image_cle1), ImgNewKeyframe);
  poser_une_image_cle_vide1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_poser_une_image_cle_vide1")); 
  gtk_widget_add_accelerator (poser_une_image_cle_vide1, "activate", accel_group,
                              GDK_KEY_F7, (GdkModifierType) 0,
                              GTK_ACCEL_VISIBLE);
  ico = gdk_pixbuf_new_from_xpm_data((const char **)new_blank_keyframe_xpm);
  ImgNewBlankKeyframe = gtk_image_new_from_pixbuf(ico); 
  g_object_unref(ico);  
  gtk_widget_show (ImgNewBlankKeyframe);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (poser_une_image_cle_vide1), ImgNewBlankKeyframe);
  creer_une_interpolation_de_mouvement1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_creer_une_interpolation_de_mouvement1")); 
  ico = gdk_pixbuf_new_from_xpm_data((const char **)interpola16x16_xpm);
  ImgNewInterpola = gtk_image_new_from_pixbuf(ico);
  gtk_widget_show (ImgNewInterpola);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (creer_une_interpolation_de_mouvement1), ImgNewInterpola);
  retirer_une_image_cle1 =  GTK_WIDGET(gtk_builder_get_object (builder, "w_retirer_une_image_cle1")); 
  ico=gdk_pixbuf_new_from_xpm_data((const char **)remove_keyframe_xpm);
  ImgRemoveKeyframe =  gtk_image_new_from_pixbuf(ico);
  gtk_widget_show (ImgRemoveKeyframe);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (retirer_une_image_cle1), ImgRemoveKeyframe);

  mettre_a_blanc_image_cle1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_mettre_a_blanc_image_cle1")); 
  ico=gdk_pixbuf_new_from_xpm_data((const char **)set_keyframe_to_blank_xpm);

  mettre_a_blanc_image_cle1 = gtk_image_menu_item_new_with_mnemonic (gettext("Set the image key empty"));
  gtk_widget_show (mettre_a_blanc_image_cle1);
  gtk_container_add (GTK_CONTAINER (trames1_menu), mettre_a_blanc_image_cle1);
  
  ico=gdk_pixbuf_new_from_xpm_data((const char **)set_keyframe_to_blank_xpm);
  gtk_widget_add_accelerator (mettre_a_blanc_image_cle1, "activate", accel_group,
                              GDK_KEY_F6, (GdkModifierType) GDK_SHIFT_MASK,
                              GTK_ACCEL_VISIBLE);
  imageSetKeyframeToBlank = gtk_image_new_from_pixbuf(ico);
  gtk_widget_show (imageSetKeyframeToBlank);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mettre_a_blanc_image_cle1), imageSetKeyframeToBlank);
  
  GtkWidget *supprimer_interpolation;
  GtkWidget *imageRemoveInterpolation;
  supprimer_interpolation = GTK_WIDGET(gtk_builder_get_object (builder, "w_supprimer_interpolation")); 
  ico=gdk_pixbuf_new_from_xpm_data((const char **) remove_interpola16x16_xpm);
  imageRemoveInterpolation=gtk_image_new_from_pixbuf(ico);
  gtk_widget_show (imageRemoveInterpolation);
  g_object_unref(ico);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (supprimer_interpolation), imageRemoveInterpolation);

  /* menu format */
  taille1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_taille1"));
  couleur_de_la_page1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_couleur_de_la_page1"));
  format_animation1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_format_animation1"));

  visualisation = GTK_WIDGET(gtk_builder_get_object (builder, "menuitem_visualization1"));
  visualisation_menu = GTK_WIDGET(gtk_builder_get_object (builder, "menuitem_visualization"));

  jouer_animation1 =  GTK_WIDGET(gtk_builder_get_object (builder, "w_jouer_animation1"));
  gtk_widget_add_accelerator (jouer_animation1, "activate", accel_group,
                              GDK_KEY_Return, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  editeur_zoom_avant =  GTK_WIDGET(gtk_builder_get_object (builder, "w_editeur_zoom_avant"));
  gtk_widget_add_accelerator (editeur_zoom_avant, "activate", accel_group,
                              GDK_KEY_KP_Add, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  editeur_zoom_arriere =  GTK_WIDGET(gtk_builder_get_object (builder, "w_editeur_zoom_arriere"));
  gtk_widget_add_accelerator (editeur_zoom_arriere, "activate", accel_group,
                              GDK_KEY_KP_Subtract, (GdkModifierType) GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  /* menu help - ? */
  a_propos1 = GTK_WIDGET(gtk_builder_get_object (builder, "imagemenuitem_about"));
 

  
/* upper toolbar */

  buttonNew = GTK_WIDGET(gtk_builder_get_object (builder, "b_new"));
  buttonSave = GTK_WIDGET(gtk_builder_get_object (builder, "b_save"));
  buttonPaste = GTK_WIDGET(gtk_builder_get_object (builder, "b_paste"));
  buttonCut = GTK_WIDGET(gtk_builder_get_object (builder, "b_cut"));
  buttonCopy = GTK_WIDGET(gtk_builder_get_object (builder, "b_copy"));
  buttonUndo = GTK_WIDGET(gtk_builder_get_object (builder, "b_undo"));
  buttonRedo = GTK_WIDGET(gtk_builder_get_object (builder, "b_redo"));

/* end upper toolbar */

  hbox1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_hbox1"));

/* left (editor) toolbar */
  HandleBoxEditor = GTK_WIDGET(gtk_builder_get_object (builder, "w_toolbarEditor"));
/* notebook */
  notebook1 = GTK_WIDGET(gtk_builder_get_object (builder, "w_notebook1"));
  ScrolledWindowEditor =  GTK_WIDGET(gtk_builder_get_object (builder, "w_ScrolledWindowEditor"));

 /* items of the editor's statusbar */
  GtkWidget *hbox35EditorBas;
  hbox35EditorBas = GTK_WIDGET(gtk_builder_get_object (builder, "w_hbox_editor"));

  

  GtkWidget* checkbuttonEditorAttractionMagnetic;
  checkbuttonEditorAttractionMagnetic = GTK_WIDGET(gtk_builder_get_object (builder, "chb_magnetism"));

  label51EditorCouleurPP = GTK_WIDGET(gtk_builder_get_object (builder, "w_label_fc")); 
  drawingarea1EditorCouleurPP = GTK_WIDGET(gtk_builder_get_object (builder, "w_drawingarea1EditorCouleurPP"));
  label52CouleurAP = GTK_WIDGET(gtk_builder_get_object (builder, "w_label_oc"));
  drawingarea2CouleurAP = GTK_WIDGET(gtk_builder_get_object (builder, "w_drawingarea2CouleurAP"));
 

  editor_store_preview(drawingarea1EditorCouleurPP, drawingarea2CouleurAP);
 
  comboBoxZoom = GTK_WIDGET(gtk_builder_get_object (builder, "w_zoom_hscale"));
  
  gtk_adjustment_set_value(GTK_ADJUSTMENT(gtk_builder_get_object (builder, "adj_zoom")), 100);

  labelEditorMousePosition = GTK_WIDGET(gtk_builder_get_object (builder, "w_labelEditorMousePosition")); 
  labelEditorHelp = GTK_WIDGET(gtk_builder_get_object (builder, "w_labelEditorHelp"));

  entryXPosProperties = GTK_SPIN_BUTTON(gtk_builder_get_object (builder, "w_entryXPosProperties")); 
  entryYPosProperties = GTK_SPIN_BUTTON(gtk_builder_get_object (builder, "w_entryYPosProperties")); 
  entryWidthProperties = GTK_SPIN_BUTTON(gtk_builder_get_object (builder, "w_entryWidthProperties")); 
  entryHeightProperties = GTK_SPIN_BUTTON(gtk_builder_get_object (builder, "w_entryHeightProperties"));
  checkbuttonConstrainProperties = GTK_WIDGET(gtk_builder_get_object (builder, "w_checkbuttonConstrainProperties"));

  labelTitreCouleursProperties = GTK_WIDGET(gtk_builder_get_object (builder, "w_labelTitreCouleursProperties"));  

  tablePropertiesColors = GTK_WIDGET(gtk_builder_get_object (builder, "w_tablePropertiesColors"));  
  spinbuttonPropertiesLineWidth = GTK_WIDGET(gtk_builder_get_object (builder, "w_spinbuttonPropertiesLineWidth"));
  
  /* end 'properties' */

 
/* panel transitions */


  scrolledwindowTransitions = GTK_WIDGET(gtk_builder_get_object (builder, "w_scrolledwindowTransitions"));    
  checkbuttonInterpola = GTK_WIDGET(gtk_builder_get_object (builder, "w_checkbuttonInterpola"));
  /* zoom */
  checkbuttonZoom = GTK_WIDGET(gtk_builder_get_object (builder, "w_checkbuttonZoom"));
  /* rotation */
  checkbuttonRotation = GTK_WIDGET(gtk_builder_get_object (builder, "w_checkbuttonRotation"));
  /* alpha */
   checkbuttonAlphaT = GTK_WIDGET(gtk_builder_get_object (builder, "w_checkbuttonAlphaT"));
  /* morphing */
  checkbuttonMorphing = GTK_WIDGET(gtk_builder_get_object (builder, "w_checkbuttonMorphing"));
 
/* library */ 
  scrolledwindowBiblio = GTK_WIDGET(gtk_builder_get_object (builder, "w_scrolledwindowBiblio")); 

  buttonBiblioArchive = GTK_WIDGET(gtk_builder_get_object (builder, "w_buttonBiblioArchive")); 
  buttonBiblioOpenArchive = GTK_WIDGET(gtk_builder_get_object (builder, "w_buttonBiblioOpenArchive")); 
  buttonBiblioRemove = GTK_WIDGET(gtk_builder_get_object (builder, "w_buttonBiblioRemove"));
  
  /* main window geometry */
  gpointer *data_geo=g_new(gpointer, 6);
  data_geo[0]=window_ella;
  data_geo[1]=&x_fen;
  data_geo[2]=&y_fen;
  data_geo[3]=&w_fen;
  data_geo[4]=&h_fen;

    /* Set our toolbar to have a primary toolbar style, FIXME: it should be
     * handled by galde. */
    gtk_style_context_add_class(gtk_widget_get_style_context(GTK_WIDGET(gtk_builder_get_object(builder,
            "toolbar_horizontale"))),
        "primary-toolbar");

    init_canvas_editor(ScrolledWindowEditor, NULL);/* variable exportée vers editeur.h */
    EllaUIPanel* panel = ella_properties_panel_new(builder);
    timeline = ella_timeline_new();
    EllaLayer* layer = ella_layer_new();
    ella_layer_set_id(layer, "New layer");
    ella_canvas_add_layer(canvas, layer);
    ella_canvas_select_layer(canvas, layer);
    ella_timeline_add_layer(timeline, layer);
    layers_list = g_slist_append(layers_list, layer);

    ella_fonts_list(GTK_LIST_STORE(gtk_builder_get_object(builder, "fonts_liststore")));

    /* The renderer of our fonts combo box */
	gtk_cell_renderer_set_fixed_size(GTK_CELL_RENDERER(gtk_builder_get_object(builder, "cellrenderertext2")), -1, 20);

    gtk_box_pack_start(GTK_BOX(gtk_builder_get_object (builder, "vbox_timeline")), GTK_WIDGET(timeline), TRUE, TRUE, 0);
    g_signal_connect(timeline, "layer-changed",
        G_CALLBACK(timeline_on_layer_changed),
        NULL);
    g_signal_connect(timeline, "keyframe-added",
        G_CALLBACK(timeline_on_keyframe_added),
        NULL);

    g_signal_connect(ella_timeline_get_layers(timeline), "layer-hidden",
        G_CALLBACK(timeline_on_layer_hidden),
        NULL);
    g_signal_connect(ella_timeline_get_ruler(timeline), "position-changed",
        G_CALLBACK(timeline_on_position_changed),
        NULL);
    
    
  g_signal_connect (canvas, "frame_changed",
                    G_CALLBACK (editor_on_frame_changed),
                    NULL);
  g_signal_connect (canvas, "stop_play",
                    G_CALLBACK(on_canvas_stop),
                    gtk_builder_get_object(builder, "button1"));

  g_signal_connect ((gpointer) comboBoxZoom, "value-changed",
                    G_CALLBACK (on_combobox_zoom_changed),
                    NULL);
    
  g_signal_connect ((gpointer) window_ella, "delete_event",
                    G_CALLBACK (on_window_ella_delete_event),
                    data_geo);

  /*g_signal_connect ((gpointer) recent1, "activate",
                    G_CALLBACK (on_recent1_activate),
                    window_ella);
  g_signal_connect ((gpointer) recent2, "activate",
                    G_CALLBACK (on_recent2_activate),
                    window_ella);
  g_signal_connect ((gpointer) recent3, "activate",
                    G_CALLBACK (on_recent3_activate),
                    window_ella);
  g_signal_connect ((gpointer) recent4, "activate",
                    G_CALLBACK (on_recent4_activate),
                    window_ella);
  g_signal_connect ((gpointer) recent5, "activate",
                    G_CALLBACK (on_recent5_activate),
                    window_ella);
  g_signal_connect ((gpointer) recent6, "activate",
                    G_CALLBACK (on_recent6_activate),
                    window_ella);
  g_signal_connect ((gpointer) quitter1, "activate",
                    G_CALLBACK (on_quitter1_activate),
                    data_geo);*/
  /* pass more than one var */
  
  gpointer *data_edition = g_new (gpointer, 5);
  data_edition[0] = GTK_WIDGET(gtk_builder_get_object (builder, "edit_copy"));
  data_edition[1] = GTK_WIDGET(gtk_builder_get_object (builder, "edit_paste"));
  data_edition[2]=  GTK_WIDGET(gtk_builder_get_object (builder, "edit_cut"));;
  data_edition[3]=  GTK_WIDGET(gtk_builder_get_object (builder, "edit_undo"));;		
 
  
  g_signal_connect ((gpointer) rotation1, "activate",
                    G_CALLBACK (on_rotation1_activate),
                   NULL);
  g_signal_connect ((gpointer) _90sens_horaire1, "activate",
                    G_CALLBACK (on_90sens_horaire1_activate),
                    NULL);
  g_signal_connect ((gpointer) _90_anti_horaire1, "activate",
                    G_CALLBACK (on_90_anti_horaire1_activate),
                    NULL);		
  g_signal_connect ((gpointer) _180_sens_horaire1, "activate",
                    G_CALLBACK (on_180_sens_horaire1_activate),
                    NULL);
  g_signal_connect ((gpointer) _270_sens_horaire1, "activate",
                    G_CALLBACK (on_270_sens_horaire1_activate),
                    NULL);	
  g_signal_connect ((gpointer) align_items1, "activate",
                    G_CALLBACK (on_align_items1_activate),
                    NULL);											   
  g_signal_connect ((gpointer) tout_selectionner1, "activate",
                    G_CALLBACK (on_tout_selectionner1_activate),
                    NULL);
  g_signal_connect ((gpointer) deselectionner_tout1, "activate",
                    G_CALLBACK (on_deselectionner_tout1_activate),
                    NULL);
  g_signal_connect ((gpointer) supprimer1, "activate",
                    G_CALLBACK (on_supprimer1_activate),
                    NULL);
 /* passer plusieurs vars */
  
  gpointer *data_trames = g_new (gpointer, 10);
  data_trames[0] = inserer_trames;
  data_trames[1] = ajouter_apres_la_position_courante1;
  data_trames[2]=  supprimer2;
  data_trames[3]=  supprimer_apres_la_position_courante1;					
  data_trames[4]= poser_une_image_cle1;
  data_trames[5]= poser_une_image_cle_vide1;
  data_trames[6]= creer_une_interpolation_de_mouvement1;
  data_trames[7]= retirer_une_image_cle1;
  data_trames[8]= mettre_a_blanc_image_cle1;
  data_trames[9]= supprimer_interpolation;
	

  g_signal_connect ((gpointer) taille1, "activate",
                    G_CALLBACK (on_taille1_activate),
                    NULL);
  g_signal_connect ((gpointer) couleur_de_la_page1, "activate",
                    G_CALLBACK (on_couleur_de_la_page1_activate),
                    NULL);
  /* passer deux vars */
  
  gpointer *data = g_new (gpointer, 4);
  data[0] = notebook1;
  data[1] = NULL;
  data[2] =  NULL;
  data[3] =  NULL;

/* boutons onglet 'propriétés' */
   /* on connecte à la même fonction contenue dans editor.c */
      g_signal_connect((gpointer) entryXPosProperties, "value-changed",
                            G_CALLBACK (editor_react_properties_entries),
                            (gint*)FIELD_X);
      g_signal_connect((gpointer) entryYPosProperties, "value-changed",
                            G_CALLBACK (editor_react_properties_entries),
                            (gint*)FIELD_Y);
      g_signal_connect((gpointer) entryWidthProperties, "value-changed",
                            G_CALLBACK (editor_react_properties_entries),
                            (gint*)FIELD_W);
      g_signal_connect((gpointer) entryHeightProperties, "value-changed",
                            G_CALLBACK (editor_react_properties_entries),
                            (gint*)FIELD_H);

  /* onglet propriétés : parties 'styles'    */			
      gpointer *data_styles=g_new(gpointer,15);
	  data_styles[10]=spinbuttonPropertiesLineWidth;/* épaisseur ligne */
	  data_styles[11]=NULL;
      data_styles[13] = panel->ecs;
      data_styles[14] = panel->ecs_stroke;
	  /* transférer le pointeur vers l'éditeur */
	  editor_store_pointer_to_styles(data_styles);
	  /* brancher les callbacks */

    
    g_signal_connect (panel->ecs, "value-changed",
                    G_CALLBACK (editor_react_properties_styles_entries),
                    data_styles);
    g_signal_connect (panel->ecs_stroke, "value-changed",
                    G_CALLBACK (editor_react_properties_styles_entries),
                    data_styles);
    g_signal_connect  ((gpointer) spinbuttonPropertiesLineWidth, "value_changed",
                            G_CALLBACK (editor_react_properties_styles_entries),
                            data_styles);

/* boutons de l'onglet bibliothèque */
      /* >> gérés dans le module 'biblio.c' */ 
  
/* buttons for horizontal toolbar */
  g_signal_connect ((gpointer) buttonNew, "clicked",
                    G_CALLBACK (on_buttonNew_clicked),
                    window_ella);
  g_signal_connect ((gpointer) buttonCopy, "clicked",
                    G_CALLBACK (on_buttonCopy_clicked),
                    NULL);
  g_signal_connect ((gpointer) buttonPaste, "clicked",
                    G_CALLBACK (on_buttonPaste_clicked),
                    NULL);
  g_signal_connect ((gpointer) buttonCut, "clicked",
                    G_CALLBACK (on_buttonCut_clicked),
                    NULL);

    gtk_window_add_accel_group (GTK_WINDOW (window_ella), accel_group);
	      
    /* init store biblio */
    pBiblio=biblio_init(scrolledwindowBiblio,
                      buttonBiblioRemove,buttonBiblioArchive,buttonBiblioOpenArchive);			 
    /* initalisation biblio */
    gtk_builder_connect_signals (builder, NULL);

    return builder;
}

/**********************************
 * fonction principale
 * *******************************/
int main (int argc, char *argv[])
{
    GtkBuilder* window_ella;
    /*GtkWidget* w_splash;*/

    GError *error = NULL;
    GOptionContext *context;

    /* Translations. */
    setlocale(LC_ALL, "" );
    bindtextdomain("ella", ELLA_NLS_LOCALEDIR);
    textdomain("ella");

    /* Init GTK. */
    gtk_init(&argc, &argv);

    /* Create, load, and choose config directory and file. */
    ella_check_data_dir ();
    ella_dirs_check_create_user_config_dir();
    ella_load_config();


    context = g_option_context_new ("");
    g_option_context_add_main_entries (context, entries, "ella");
    g_option_context_add_group (context, gtk_get_option_group (TRUE));
    if (!g_option_context_parse (context, &argc, &argv, &error))
    {
        g_print ("Option parsing failed: %s\n", error->message);
        exit(1);
    }

    /* Show the splash screen. It works but it is annoying, uncomment to
     * enable it. */
    /*w_splash = create_window_SplashScreen ();
    gtk_widget_show_all(w_splash);*/
    /* Set a timeout, the splash screen will be destroyed when splashScreenOff
     * is called.
     * FIXME: it should be removed with the expose event of the main window, not
     * with a timeout.*/
    /*g_timeout_add(2000, splahScreenOff, (gpointer*)w_splash);*/

    /* FIXME: What is that? Please document me :) */
    set_autoarchive_biblio(ella_config_get_value_int("AUTO_ARCHIVE"));

    /* Create a tmp folder. */
    /* FIXME: this shouldn't be necessary! */
    g_mkdir(g_build_filename(getenv("HOME"), ".ella", NULL), 0777);

    /* Load default values in the editor. */
    
    editor_set_default_page_width(ella_config_get_value_double("PAGE_WIDTH"));
    editor_set_default_page_height(ella_config_get_value_double("PAGE_HEIGHT"));
    editor_set_default_margins(ella_config_get_value_double("PAGE_MARGINS"));
	
    if( ella_config_get_value_int("EXPORT_BACKGROUND")==1)
    {
        editor_set_background_export(TRUE); 
    }
    else
    {
        editor_set_background_export(FALSE);
    }

    /* Change the page color */
    editor_set_default_page_color_rgb(ella_config_get_value_double("PAGE_COLOR_RED"),
                                    ella_config_get_value_double("PAGE_COLOR_GREEN"),
                                    ella_config_get_value_double("PAGE_COLOR_BLUE"));
    
    /* Create the main window! */
    window_ella = create_window_ella();
    ella_main_builder = window_ella;

	/* set editor with THOSE values */
	editor_set_page_width(ella_config_get_value_double("PAGE_WIDTH"));
    editor_set_page_height(ella_config_get_value_double("PAGE_HEIGHT"));

    /* Load default values in the timeline. */
    timeline_set_default_movie_freq(ella_config_get_value_int("FPS"));
    timeline_set_movie_freq(ella_config_get_value_int("FPS"));
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(gtk_builder_get_object(window_ella, "w_spinbuttonMovieFrequency")), ella_config_get_value_int("FPS"));


    /* Undo Manager */
    undo_manager = ella_undo_manager_new();
    ella_canvas_set_undo_manager(canvas, undo_manager);

    /* Change the main window size, we saved this size the previous time. */
    gtk_window_resize(GTK_WINDOW(gtk_builder_get_object(window_ella, "window_ella")),
                    ella_config_get_value_double("W_FEN"),
                    ella_config_get_value_double("H_FEN"));

    gtk_widget_show_all(GTK_WIDGET(gtk_builder_get_object(window_ella, "window_ella")));

    /* center the canvas */
    on_center_activate(GTK_SCROLLED_WINDOW(gtk_builder_get_object(window_ella, "w_ScrolledWindowEditor")), NULL);

    editor_reset_item_counter();

                    
    /* Clipboard */

    if(path_file != NULL && path_file[0] != NULL)
    {
        open_file(GTK_WIDGET(gtk_builder_get_object(window_ella, "window_ella")), path_file[0]);
        if(g_slist_length(layers_list) > 1)
        {
            gtk_widget_set_sensitive(GTK_WIDGET(gtk_builder_get_object(window_ella, "w_buttonLayerRemove")), TRUE);

        }
    }

    /* GTK main loop. All is paused here, until the user presss the close button ;) */
    gtk_main();

    /* Free the memory. FIXME: This function is too small, it cleans only one icon! */
    //free_icones();

    /* Save the default config values.
     * FIXME: they should be saved in live. */
    ella_config_set_value_double("PAGE_WIDTH", editor_get_default_page_width());
    ella_config_set_value_double("PAGE_HEIGHT", editor_get_default_page_height());
    ella_config_set_value_double("PAGE_MARGINS", editor_get_default_margins());

    /* Here, the cast (gint) is necessary, since GdkColor.red|green|blue are
     * guint16. */
    ella_config_set_value_int("PAGE_COLOR_RED", (gint)editor_get_default_page_color().red);
    ella_config_set_value_int("PAGE_COLOR_GREEN", (gint)editor_get_default_page_color().green);
    ella_config_set_value_int("PAGE_COLOR_BLUE", (gint)editor_get_default_page_color().blue);

    ella_config_set_value_double("FPS", timeline_get_default_movie_freq());
    ella_config_set_value_int("MOVIE_DEFAULT_FOOTAGE", timeline_get_default_footage());	

    /* Save window geometry. */
    ella_config_set_value_int("W_FEN", w_fen);
    ella_config_set_value_int("H_FEN", h_fen);
    /* save background export  preference */
    if(editor_get_background_export())
       ella_config_set_value_int("EXPORT_BACKGROUND",1);/* activate by default */
         else
           ella_config_set_value_int("EXPORT_BACKGROUND",0);/* don't activate by default */
    /* Save the config, in ~/.config/ella/user/cfg */
    ella_save_config();

    return 0;
}
