/*
This file is part of Ella.

Ella is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Ella is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS forA PARTICULAR PURPOSE.  See the
GNU General Public License formore details.

You should have received a copy of the GNU General Public License
along with Ella.  ifnot, see <http://www.gnu.org/licenses/>.
*/
#include "timeline.h"
#include "interface_editor.h"

/* icons */
#include "./icones_rcs/ico_layer_sound.xpm"
#include "./icones_rcs/ico_layer_draw.xpm"
#include "./icones_rcs/pointeur_regle.xpm"

extern EllaTimeline* timeline;
extern gdouble animation_speed = 0;
/* réglages divers */
gint MovieFreq = 12;
gint MoviePos = 1;
static gint TimelineZoom = 100;/* valeur actuelle du zooming sur la timeline */

gint timeline_defaut_MovieFreq;
gint timeline_default_footage;
GSList* layers_list = NULL;

/*********************************
 * fonction pour connaître la
 * fréquence du film
 * ******************************/
gint timeline_get_movie_freq(void)
{
	return MovieFreq;
}
/***********************************
 * fonction pour régler la fréquence
 * du film
 * ********************************/
void timeline_set_movie_freq(gint fps)
{
    if(fps <= 0)
    {
        fps=12;
        g_warning("Wrong FPS value, it is < 0.");
    }
    MovieFreq=fps;
    ella_timeline_set_image_per_secs(timeline, fps);
    GtkSpinButton* spin_adjustment = GTK_SPIN_BUTTON(gtk_builder_get_object(ella_main_builder, "w_spinbuttonMovieFrequency"));
    gtk_adjustment_set_value(gtk_spin_button_get_adjustment(spin_adjustment), fps);
} 
void timeline_set_default_movie_freq(gint fps)
{
	if(fps<0)
	  fps=12;
	timeline_defaut_MovieFreq=fps;	
    ella_config_set_value_int("FPS", fps);
} 
gint timeline_get_default_movie_freq(void)
{
	return timeline_defaut_MovieFreq;	
}
void timeline_set_default_movie_zoom(gint zoom)
{
    switch (zoom)
    {
        case 0:
        {
            TimelineZoom = 50;
            break;
        }
        case 1:
        {
            TimelineZoom = 75;
            break;
        }
        case 2:
        {
            TimelineZoom = 100;
            break;
        }
    }
    ella_config_set_value_int("TIMELINE_ZOOM", TimelineZoom);
}
gint timeline_get_default_movie_zoom(void)
{
    return TimelineZoom;
}
/**************************
 * échanger deux valeurs
 * entières ; FULL LOCAL
 * ***********************/
void swap(int *i, int *j) 
{
   int t = *i;
   *i = *j;
   *j = t;
}

/***********************************
 * get the current default footage
 * forthe movie
 * ********************************/
gint timeline_get_default_footage(void)
{
	return 512;/* dirty, to do */
}
/******************************
 * changement du coefficient 
 * de zooming de la timeline
 * ***************************/
void timeline_set_zooming(gint z)
{
	TimelineZoom=z;
}

gboolean timeline_on_layer_changed(GtkWidget* timeline, gpointer user_data)
{
    ella_canvas_select_layer(canvas, ella_timeline_get_selected_layer(timeline));
}

gboolean timeline_on_layer_hidden(GtkWidget* timeline, EllaLayer* layer)
{
    gtk_widget_queue_draw(canvas);
}
gboolean timeline_on_position_changed(GtkWidget* timeline, gint time)
{
    ella_canvas_change_keyframe(canvas, time);
}
gboolean timeline_on_add_pressed(GtkWidget* button, GtkWidget* widget)
{
    EllaLayer* layer;
    layer = ella_layer_new();
    layers_list = g_slist_append(layers_list, layer);
    ella_layer_set_id(layer, "New layer");
    ella_canvas_add_layer(canvas, layer);
    ella_timeline_add_layer(timeline, layer);
    gtk_widget_set_sensitive(button, TRUE);
}

gint timeline_get_layers_count(void)
{
    return 1;
}

gboolean timeline_on_keyframe_added(GtkWidget* widget, gpointer user_data)
{
    /* Force the canvas to check if the fraùe is editable */
    ella_canvas_change_keyframe(canvas, ella_canvas_get_frame_number(canvas));
}
