/* Copyright (C) 2010 Lucas Baudin
 *
 * This file is part of Ella Project.
 *
 * Ella Project is free software : you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ella Project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ella Project. If not, see <http ://www.gnu.org/licenses/>.
 */

#ifndef H_PROPERTIES_PANEL_20101213
#define H_PROPERTIES_PANEL_20101213

#include <gtk/gtk.h>
#include "ella-widgets.h"

extern EllaCanvas* canvas;

typedef struct
{
    GtkWidget* expander_text;
    gboolean show_text;
    GtkTextBuffer* txt_buffer;
    gulong old_handler_id;

    GtkWidget* expander_stroke;
    GtkWidget* hseparator_stroke;
    GtkWidget* hseparator_fill;
    GtkWidget* hseparator_text;
    gboolean show_stroke;
    GtkWidget* ecs;
    GtkWidget* ecs_stroke;
    GtkWidget* line_width;
} EllaUIPanel;

typedef enum
{
    ELLA_UI_PANEL_TEXT,
    ELLA_UI_PANEL_STROKE
}EllaUIPanelField;
EllaUIPanel* ella_properties_panel_new(GtkBuilder* builder);

void ella_properties_panel_update(EllaUIPanel* panel);

void ella_properties_panel_set(EllaUIPanel* panel, EllaUIPanelField widget, gboolean visible);

#endif
